AJS.$(document).ready( function() {
	
	if (document.location.href.indexOf('JEMHAdhocProjectTab')==-1)
	{
		console.log('JEMH Project : quiting project-adhoc.js early due to JRA-32379');
		return;
	}
	else
	{
		console.log("JEMH Project : project-adhoc.js loaded");	
    }

    //Initialize Datatables
    var table = AJS.$('#template-set-table').DataTable( {
        rowReorder: {
            selector: 'tr'
        },
        columnDefs: [
            { orderable: true, className: 'reorder', targets: 0 },
            { orderable: false, targets: '_all' }
        ],
        searching: false,
        paging: false,
        "language": {
            "emptyTable": AJS.I18n.getText('jemh.adhoc.template.noTemplateSetsFound')
          }
    } );

    table.on( 'row-reorder', function ( e, diff, edit ) {
        console.log("Table has been reordered");
        setTimeout(updateTemplateSetOrderField(table), 500); //Wait for the DOM to update
    });

    function updateTemplateSetOrderField(table) {
        var rows = AJS.$("#template-set-table tr");
        var templateSetOrder = "";

        for(var i = 0; i < rows.length; i++) {
            if(i > 0) { //Skip the header row
                var currentRow = rows[i];
                var templateId = AJS.$(currentRow).find("td").eq(1).html();
                templateSetOrder = templateSetOrder + templateId;
                if(i != rows.length - 1) {
                    templateSetOrder = templateSetOrder + ",";
                }
            }
        }

        AJS.$("#templateSetOrder").val(templateSetOrder);

        postTemplateSetOrderForm();
    }

    function postTemplateSetOrderForm() {
        var formName = "#template-set-order-form";
        var postData = AJS.$(formName).serialize();
        var formUrl = AJS.$(formName).attr('action');
        var templateSetOrder = AJS.$("#templateSetOrder").val();

        var jqXHR=AJS.$.ajax({
			type:"POST",
			url:formUrl,			
			dataType:"json",
			data:postData,
			timeout:60000
        });
        
        jqXHR.done(function(data, textStatus, errorThrown) {
			if(!data) {
				if (errorThrown) {
					msg='Error: '+errorThrown;
				} else {
					msg='Unknown Error';
				}
                
                var myFlag = AJS.flag({
                    type: 'warning',
                    body: msg,
                });
            }       
         });
    }
    
    $(function() {
    	    var ccHandlingFields = '#ccHandlingFields';
	    var ccHandlingJiraUsers = '#ccHandlingJiraUsersCF';
	    var ccHandlingJiraUsersError = '#ccHandlingJiraUsersCFError';
	    var ccHandlingNonJiraUsers = '#ccHandlingNonJiraUsersCF';
	    var ccHandlingNonJiraUsersError = '#ccHandlingNonJiraUsersCFError';

	    var selectedIndexProp = 'selectedIndex';
	    var defaultSelectedIndexValue = 0;
	    
	    if(jQuery.inArray('toCustomField', $('#ccHandling').val()) < 0) {
	    	resetCcHandlingFields();
	    }
	    
	    hideField(ccHandlingJiraUsersError);
   	 	hideField(ccHandlingNonJiraUsersError); 
	    
	    $('#ccHandling').change(function(){
	    		if(jQuery.inArray('toCustomField', $('#ccHandling').val()) >= 0) {
	    			showField(ccHandlingFields);
			}
			else 
			{
				resetCcHandlingFields();
			}

			if(jQuery.inArray('none', $('#ccHandling').val()) >= 0)
			{
				resetCcHandlingFields();
				$('#ccHandling').val(['None']);
			}
	    });
	    
	    function resetCcHandlingFields(){
	    	hideField(ccHandlingFields);
	    	// Jira Users
			setProp(ccHandlingJiraUsers, selectedIndexProp, defaultSelectedIndexValue)
			hideField(ccHandlingJiraUsersError);
			// Non Jira Users
			setProp(ccHandlingNonJiraUsers, selectedIndexProp, defaultSelectedIndexValue)
       	 	hideField(ccHandlingNonJiraUsersError);
	    }
	    
	    function showField(fieldName) {
	    	$(fieldName).show();
	    }
	    
	    function hideField(fieldName) {
	    	$(fieldName).hide();
	    }
	
	    function setProp(fieldName, prop, value) {
	    	$(fieldName).prop(prop, value);
	    }
	    
	    $('#adhoc-edit-save').on('click', function(e) {
	        var isValid = true;
	        var jiraUsers = $(ccHandlingJiraUsers).val();
	        var nonJiraUsers = $(ccHandlingNonJiraUsers).val();
	        
	         if(jQuery.inArray('toCustomField', $('#ccHandling').val()) >= 0 && !jiraUsers && !nonJiraUsers) {
	        	 showField(ccHandlingJiraUsersError);
	        	 showField(ccHandlingNonJiraUsersError);
	        	 e.preventDefault(); //prevent the default action
	         } else {
	        	 hideField(ccHandlingJiraUsersError);
	        	 hideField(ccHandlingNonJiraUsersError);
	         }
	    });
	});

	AJS.$('#addresseeHandlingHelp').click(function(e){
            var win = window.open("https://thepluginpeople.atlassian.net/wiki/spaces/JEMH/pages/29655110/Use+Adhoc+Notifications#Auto-Updating-Recipients-on-the-Issue", '_blank');
            win.focus();
        });
});