AJS.$(document).ready( function(){
    console.log('JEMH auditing-report script loaded');

    AJS.$(function(){var toggle=new JIRA.ToggleBlock({blockSelector:".toggle-wrap",triggerSelector:".mod-header h3"})});

    function addEntry(entry) {
        var entryHtml;

        if (entry.message!=null && entry.exceptionType==null)
        {
            if (entry.format)
            {
                if (entry.format=="pre")
                {
                    entryHtml=entry.title+"<pre style='display: block; padding: 5px; border:1px solid black; background-color: #F0F7FF; font-family: monospace; white-space: pre-wrap; margin: 1em 0; word-wrap: break-word;'>"+htmlEncode(entry.message)+"</pre>";
                }
                else if (entry.format=="code")
                {
                    entryHtml=entry.title+"<code style='display: block; padding: 5px; border:1px solid black; background-color: #F0F7FF; font-family: monospace; white-space: pre-wrap; margin: 1em 0; word-wrap: break-word;'>"+htmlEncode(entry.message)+"</code>";
                }
                else
                {
                    entryHtml=entry.title+"<pre style='display: block; padding: 5px; border:1px solid black; background-color: #F0F7FF; font-family: monospace; white-space: pre-wrap; margin: 1em 0; word-wrap: break-word;'>Unknown format ("+entry.format+") "+htmlEncode(entry.message)+"</pre>";
                }
            }
            else
            {
                entryHtml=htmlEncode(entry.message);
            }
        }
        else
        {
            entryHtml='<table class="jemh-audit-exception-entry">';
            if (entry.message) {
                entryHtml+='<tr><th>Message</th><td>'+htmlEncode(entry.message)+'<td></tr>';
            }
            if (entry.valueSupplied) {
                entryHtml+='<tr><th>Value Supplied</th><td><pre>'+htmlEncode(entry.valueSupplied)+'</pre><td></tr>';
            }
            if (entry.validValues) {
                entryHtml+='<tr><th>Valid Values</th><td><pre>'+htmlEncode(entry.validValues)+'</pre><td></tr>';
            }
            if (entry.exceptionType) {
                entryHtml+='<tr><th>Exception Type</th><td>'+htmlEncode(entry.exceptionType)+'<td></tr>';
            }
            if (entry.exceptionMessage) {
                entryHtml+='<tr><th>Exception Msg</th><td>'+htmlEncode(entry.exceptionMessage)+'<td></tr>';
            }
            if (entry.exceptionStack) {
                entryHtml+='<tr><th>Exception Stack</th><td><code>'+htmlEncode(entry.exceptionStack)+'</code><td></tr>';
            }
            entryHtml+='</table>';
        }

        return entryHtml;
    }

    function addSection(json, section){
        var sectionHtml='<div class="jemh-audit-section"><h2 class="jemh-audit-section-heading">'+section+'</h2>';

        sectionHtml+='<UL class="jemh-audit-section-list">'
        for(var j = 0; j < json.messages[section].length; j++) {
            //console.log(j+'.  '+json.messages[section][j]);
            sectionHtml+='<LI class="jemh-audit-section-list-item">'+addEntry(json.messages[section][j])+'</LI>';
        }
        sectionHtml+="</UL></div>";

        var newSectionElement = AJS.$(sectionHtml);
        AJS.$('#jemhAuditReportText').append(newSectionElement);
    }

    function buildReportPage(json) {
        for(var i = 0; i < json.sections.length; i++) {
            addSection(json, json.sections[i]);
        }
    }

    function getReport() {
        console.log('getReport()');
        var eventId=AJS.$("#auditEventId").val();
        if (eventId<0) {
            AJS.$("#enableAuditingHint").show("fast");
        }
        else {
            var jemhReportUri=AJS.contextPath() + "/rest/jemh/latest/auditing/auditevent/report/"+eventId+"?atl_token="+AJS.$('#jemh-ajs-atl-token').val();
            AJS.$.get(jemhReportUri)
                .done(function(data) {
                    if(data.errors) {
                        console.error('getReport() failed');
                    }
                    else {
                        buildReportPage(JSON.parse(data.report));
                    }
                    AJS.$(".report-loading-spinner").spinStop();
                }).fail(function(data, textStatus, errorMessage) {
                console.error("getReport() fail; textStatus="+textStatus+", errorMessage: "+errorMessage);
                AJS.$(".report-loading-spinner").spinStop();
            });
        }
    }

    //Show report on Project Audit section (JEMH-7459)
    AJS.$('#report-section').click(function() {
        getReport();
    });

});
