function reprocess(event, id) {
	event.preventDefault();
	var jqXHR=AJS.$.ajax({
		type:"POST",
		url:AJS.contextPath()+"/rest/jemh/1.0/auditing/reprocessing/reanimate?id="+id+"&atl_token="+atl_token(),
		timeout:5000});
	
	jqXHR.done(function(data, textStatus, errorMessage) {
		AJS.messages.success("#jemh-auditing-messages", {
		    title: "Re-animation complete!",
		    body: "Please reload or navigate to <A HREF='"+AJS.contextPath()+"/secure/admin/jemh/JEMHAuditing.jspa'>Auditing page</A> to see updates",
		    fadeout: true
		});
	}).fail(function(data, textStatus, errorMessage) {
		AJS.messages.error("#jemh-auditing-messages", {
		    title: "Re-animation failed",
		    body: "errorMessage: "+errorMessage
		});
	});									
}
function popupEmailDetail(event, id) {

	event.preventDefault();
		
	var detailUrl=AJS.contextPath()+'/rest/jemh/latest/auditing/auditevent/detail?id='+id+'&atl_token='+atl_token();
	var jqXHR=AJS.$.getJSON(detailUrl, {
			format: "json"
	});
		
	//http/dev-jira:8080/rest/jemh/latest/auditing/auditevent/detail/883
	jqXHR.done(function(data, textStatus, errorMessage) {	
		if(data.errors) {
			console.log('popupEmailDetail() errors');					
		}
		else {
			var dialog = new AJS.Dialog({
			    width: 800, 
			    height: 600, 
			    id: "jemh-audit-detail-popup-dialog", 
			    closeOnOutsideClick: true
			});
		
			// PAGE 0 (first page)
			// adds header for first page
			dialog.addHeader("Email Detail");
			
			if (data.toArr) {
				var toContent='<UL>';
				for (var i=0 ; i<data.toArr.length ; i++)
		    	{
		    		console.log('to: '+data.toArr[i]);
		    	    toContent=toContent+'<LI>'+AJS.escapeHtml(data.toArr[i])+'</LI>';
		    	}
		    	toContent=toContent+'</UL>';
				dialog.addPanel("To:", "<UL class='aui'>"+toContent+"</UL>", "panel-body");
			}
			
	    	if (data.ccArr) {
				var ccContent='<UL>';
				for (var i=0 ; i<data.ccArr.length ; i++)
		    	{
		    		console.log('cc: '+data.ccArr[i]);
		    	    ccContent=ccContent+'<LI>'+AJS.escapeHtml(data.ccArr[i])+'</LI>';
		    	}
		    	ccContent=ccContent+'</UL>';
				dialog.addPanel("Cc:", "<UL class='aui'>"+ccContent+"</UL>", "panel-body");
	    	}
	    	
			var headerContent='<table class="aui"><tr><th>Header</th><th>Value</th></tr>';	    	
			for (var i = 0, keys = Object.keys(data.headers), ii = keys.length; i < ii; i++) {
  				console.log('header : ' + keys[i] + ' = ' + data.headers[keys[i]]);
  				headerContent=headerContent+'<tr><th>'+AJS.escapeHtml(keys[i])+'</th><td>'+AJS.escapeHtml(data.headers[keys[i]])+'</td></tr>';
			}	    	
			headerContent=headerContent+'</table>';			
			dialog.addPanel("Headers", headerContent, "panel-body");
			
			dialog.addPanel("Content", '<pre>'+data.content+'</pre>', "panel-body");
			
			// adds "Cancel" button to page 1
			dialog.addButton("Close", function (dialog) {
			    dialog.hide();
			});
			
			dialog.gotoPage(0);
		    dialog.gotoPanel(0);
		    dialog.show();
		}
	}).fail(function(data, textStatus, errorMessage) {
		console.log("popupEmailDetail() failed: "+textStatus+" : "+detailUrl);
	});
}

//REPROCESSING
AJS.$(document).ready( function(){
	
	function enableOperationButtons()
	{
		AJS.$('.reprocessing-button').attr('disabled','');
		AJS.$('.reprocessing-button').prop('disabled', null);
	}
	function disableOperationButtons()
	{
		AJS.$('.reprocessing-button').attr('disabled','disabled');
	}
		
	function checkForUpdate()
	{
		console.log('checkForUpdate()');
		var jemhUpdateUri=AJS.contextPath()+"/rest/jemh/1.0/auditing/reprocessing/status.json";
		var jqXHR=AJS.$.getJSON(jemhUpdateUri, {
			atl_token: atl_token(),
			format: "json",
			})
			.done(function(data, textStatus, errorMessage) {
			console.log("getStatus() done - success; data="+data+", textStatus:"+textStatus+", errorMessage: "+errorMessage);
			if(data.errors) {
				console.log('getStatus() errors');
			}
			else {
				console.log('JEMH audit history update received');
				if (data.auditId>0)
				{
					AJS.$('#jemhAuditId').text(data.auditId);
				}
				AJS.$('#jemhTimestamp').text(data.timestamp);
				AJS.$('#jemhFrom').text(data.fromAddress);
				
				if (data.subject) {
					if (data.subject.len>60) {
						var willBe=data.subject.substring(0,60)+' ...'
						AJS.$('#jemhSubject').text(willBe);
					} else {
						AJS.$('#jemhSubject').text(data.subject);
					}
				} else {
				   AJS.$('#jemhSubject').text('');
				}

				AJS.$('#jemhOutcome').text(data.processingOutcome);
				if (data.type)
				{
					AJS.$('#jemhProcessingType').text(data.type+ ' ('+data.recordsToProcess+' records matched)');
				}
				if (data.exception)
				{
					AJS.$('#jemhException').text(data.exception);
					AJS.$('#jemhExceptionDiv').show();
				}
				else
				{
					AJS.$('#jemhException').text('');
					AJS.$('#jemhExceptionDiv').hide();
				}
				
				//status
				AJS.$('#jemhPercent').text(data.percent+'%');
				AJS.$('#jemhStatus').text(data.status);

				AJS.$("#jemhReprocessingProgressBar").animate({width: (400 * data.percent /100) + 'px'}, 500);
				
				if (data.processingStatus=='notRunning')
				{
					enableOperationButtons();
					if (data.recordsProcessed>0)
					{									
						AJS.$('#jemhStatus').text('Finished ('+data.recordsProcessed+' records)');
					}
				}
				else
				{
					disableOperationButtons();
					setTimeout(function() { checkForUpdate(); },3000);
				}
			}
		}).fail(function(data, textStatus, errorMessage) {
			console.log("getStatus() fail; textStatus="+textStatus+", errorMessage: "+errorMessage);
		});					
	}
	
	AJS.$('#auditingReProcessingSubmitButton').click(function(event) {
        event.preventDefault();
        disableOperationButtons();
		AJS.$('.jemhDataField').text('');
		AJS.$('#jemhReprocessingProgressBar').attr('width',0+'px');
		
		console.log('Reprocessing submit button clicked');
		var jqXHR=AJS.$.ajax({
			type:"POST",
			dataType:"json",
			contentType: "application/json; charset=utf-8",
			url:AJS.contextPath()+"/rest/jemh/1.0/auditing/reprocessing/run",
			params: {alt_token: atl_token()},
			timeout:15000});
		
		jqXHR.done(function(data, textStatus, errorMessage) {
			setTimeout(function() { checkForUpdate(); },5000);
		}).fail(function(data, textStatus, errorMessage) {
			console.log("RUN fail: textStatus="+textStatus+", errorMessage: "+errorMessage);
			AJS.$('#jemhException').text('Run failed, status: '+textStatus+', error: '+errorMessage);
			AJS.$('#jemhExceptionDiv').hide();
			enableOperationButtons();
		});
    });	
    
    AJS.$('#auditingReProcessingDownloadListButton').click(function(event) {
    	event.preventDefault();
    	document.location=AJS.contextPath()+"/rest/jemh/1.0/auditing/reprocessing/list?atl_token=" + atl_token() + "&filename=audithistory-list.csv";
    });

	AJS.$('#auditingReProcessingCheckMatchesButton').click(function(event) {
		event.preventDefault();
		AJS.$('.jemhDataField').text('');
		AJS.$('#jemhReprocessingProgressBar').attr('width',0+'px');

		var jqXHR = AJS.$.ajax({
			type: "POST",
			dataType: "json",
			contentType: "application/json; charset=utf-8",
			url: AJS.contextPath() + "/rest/jemh/1.0/auditing/reprocessing/check",
			timeout: 15000,
			params: {alt_token: atl_token()},
			beforeSend: function () {
				disableOperationButtons();
			}
		});

		jqXHR.done(function(data, textStatus, errorMessage) {
			if (data) {
				if(data.errors) {
					console.log('getStatus() errors');
				} else {
					if (data.type)
					{
						var dd = new Date();
						var hh = dd.getHours();
						var mm = dd.getMinutes();
						var ss = dd.getSeconds();
						AJS.$('#jemhProcessingType').text(data.type+ ' ('+data.recordsToProcess+' records matched @ '+hh+':'+mm+':'+ss+')');
					}
				}
			}
		}).fail(function(jqXHR, textStatus, errorThrown) {
			console.log("CHECK fail: textStatus="+textStatus+", errorMessage: "+errorThrown);
			AJS.$('#jemhException').text('Run failed, status: '+textStatus+', error: '+errorThrown);
			AJS.$('#jemhExceptionDiv').show();
		}).always(function () {
			enableOperationButtons();
		});
    });						    

    checkForUpdate();			
 });

//PURGE
AJS.$(document).ready( function(){
var lastAuditHistoryEventLoaded=0;
var IMAGE_BASE=AJS.contextPath()+'/download/resources/com.javahollic.jira.jemh-ui:jemh-images/icons';
	
	function disableAuditPurgeButton()
	{
		AJS.$('.audit-purge-button').attr('disabled','disabled');
	}
	function enableAuditPurgeButton()
	{
		AJS.$('.audit-purge-button').attr('disabled','');
		AJS.$('.audit-purge-button').prop('disabled', null);
	}

	function cleanPurgeDataFields()
	{
		AJS.$('.purgeDataField').text('');
		AJS.$('#jemhPurgeProgressBar').attr('width',0+'px');
	}

	//"status":"NOT_RUNNING","datasize":0,"eventsFound":47,"eventsRetained":27,"eventsDeleted":20,
	//"deletedBytes":1647440,"lastProcessedId":12117,"percentOverall":0,"timeStarted":"26/06/13 00:19:56",
	//"timeCompleted":"26/06/13 00:19:56","percentDeleted":42,"percentRetained":57}
	function checkPurgeStatus()
	{
		console.log('checkPurgeStatus()');
		var jemhPurgeStatusUri=AJS.contextPath()+"/rest/jemh/1.0/auditing/purge/status.json?atl_token=" + atl_token();
		var jqXHR=AJS.$.getJSON(jemhPurgeStatusUri, {
			format: "json"
			})
			.done(function(data, textStatus, errorMessage) {
			console.log("getPurgeStatus() done - success; data="+data+", textStatus:"+textStatus+", errorMessage: "+errorMessage);
			if(data.errors) {
				console.log('getPurgeStatus() errors');					
			}
			else {
				console.log('PurgeStatus received');				
				AJS.$('#jemhAuditPurgeStatus').text(data.status);
				AJS.$('#jemhAuditPurgeEventsFoundInRange').text(data.eventsFound);
				AJS.$('#jemhAuditPurgeDeletedEvents').text(data.eventsDeleted +' Events Deleted');
				AJS.$('#jemhAuditPurgeRetainedEvents').text(data.eventsRetained+' Events Retained');

				AJS.$('#jemhAuditPurgeSize').text((data.deletedBytes/1024/1024).toFixed(1)+' Mb');
				AJS.$('#jemhAuditPurgeLastProcessed').text(data.lastProcessedId);
				AJS.$('#jemhAuditPurgeStarted').text(data.timeStarted);
				AJS.$('#jemhAuditPurgeCompleted').text(data.timeCompleted);

				console.log('percent deleted: '+data.percentDeleted);
				AJS.$('#jemhAuditPurgeDeletePercent').text(data.percentDeleted+'%');
				AJS.$('#jemhAuditPurgeDeleteProgressBar').animate({width: (400 * data.percentDeleted /100) + 'px'}, 500);

				AJS.$('#jemhAuditPurgeRetainPercent').text(data.percentRetained+'%');
				AJS.$('#jemhAuditPurgeRetainProgressBar').animate({width: (400 * data.percentRetained /100) + 'px'}, 500);
				console.log('percent retained: '+data.percentRetained);
				
				if (data.exception)
				{
					AJS.$('#jemhPurgeException').text(data.exception);
					AJS.$('#jemhPurgeExceptionDiv').show();
				}
				else
				{
					AJS.$('#jemhPurgeException').text('');
					AJS.$('#jemhPurgeExceptionDiv').hide();
				}
				
				if (data.status=='NOT_RUNNING')
				{
					console.log('purge is complete, or not running.');
					enableAuditPurgeButton();
				}
				else
				{
					console.log('purge is still running, checking again in 3S');
					disableAuditPurgeButton();
					setTimeout(function() { checkPurgeStatus(); },3000);
				}
			}
		}).fail(function(data, textStatus, errorMessage) {
			console.log("getStatus() fail; textStatus="+textStatus+", errorMessage: "+errorMessage);
		});	
	}
	
	//NEW AJAX Audit History
	
	AJS.$('#jemh-audithistory-search-form').submit(function(e) {
		return false; //http://stackoverflow.com/questions/1357118/event-preventdefault-vs-return-false
	});
	
	AJS.$('#jemh-auditevents-latest-results-button').click(function(event) {
		lastAuditHistoryEventLoaded=0
		AJS.$(".jemh-auditing-data-row").remove();
		pollServerForAuditEvents();
	});

	AJS.$('#jemh-auditevents-clear-results-button').click(function(event) {
		AJS.$(".jemh-auditing-data-row").remove();
	});
	
	AJS.$('#jemh-auditevents-page-size').change(function(ev) {
		var auditHistoryPageSize=AJS.$("#jemh-auditevents-page-size option:selected").val();
    	while ( AJS.$("#jemh-auditevents-table > tbody > tr").length >=auditHistoryPageSize )
    	{
    		AJS.$("#jemh-auditevents-table > tbody > tr:last").remove();
		}
	});
	
	AJS.$('.jemh-search-method').change(function(ev) {
    	AJS.$(".jemh-search-by-field").hide();
    	var searchByClass=".jemh-search-by-"+AJS.$(".jemh-search-method option:selected").val();
        AJS.$(searchByClass).show();    		
	});
	
	AJS.$('#jemh-auditevents-autoupdate').click(function() {
		if (this.checked) {
			restartAutoUpdate();
		} else {
			stopAutoUpdate();
		}
	});
	
	AJS.$('#jemh-event-update-period').change(function() {
		if (AJS.$('#jemh-auditevents-autoupdate').is(':checked')) {
			restartAutoUpdate();
		}
	});

    // AJS.$( "#notBefore" ).datePicker({'overrideBrowserDefault': true});
    // AJS.$( "#notAfter" ).datePicker({'overrideBrowserDefault': true});
	
	AJS.$('#searchButton').click(function(event) {
		//stop auto update
		executeHistorySearch();
	});
	
	if (AJS.$('div#page').hasClass('jemh-popup')) {
		AJS.$('#jemh-history-popup').hide();
	}
	
	var auditingWindowRef = null;
	AJS.$('#jemh-history-popup').click(function(event) {
		event.preventDefault();
		var strWindowFeatures = "resizable,scrollbars,status,location,width=1024,height=768";
		if (auditingWindowRef == null || auditingWindowRef.closed) {
			auditingWindowRef = window.open(AJS.contextPath()+'/secure/admin/jemh/JEMHAuditing!popupSearch.jspa', "JEMHAuditingWindow", strWindowFeatures);
		}
		else {
			auditingWindowRef.focus();
		}
	});

	function htmlDecode(value){
	  return AJS.$('<div/>').html(value).text();
	}
		
	function executeHistorySearch() {
		
		//stop auto-update, reflect in UI
		stopAutoUpdate();
		AJS.$('#jemh-auditevents-autoupdate').removeAttr('checked');
		AJS.$(".jemh-auditing-data-row").remove();
		
		AJS.$('#jemh-auditevents-searchresults').html("<span class='aui-icon aui-icon-wait'>Loading, please wait</span>");

		//store page size in the form		
		var auditHistoryPageSize=AJS.$("#jemh-auditevents-page-size option:selected").val()
		AJS.$('#pageSize').val(auditHistoryPageSize);
		
		// build data
		var postData=AJS.$('#jemh-audithistory-search-form').serialize();
		var formUrl = AJS.$('#jemh-audithistory-search-form').attr('action');
		
		var jqXHR=AJS.$.ajax({
			type:"POST",
			url:formUrl,			
			dataType:"json",
			data:postData,
			timeout:30000});
		
		jqXHR.done(function(data, textStatus, errorThrown) {
			if(data.errors) {
				if (errorThrown)
				{
					console.error('auditevent Search Error: '+errorThrown);
				}
				else
				{
					console.error('auditevent Search Error');
				}					
			}
			else {
				console.log('search completed, found '+data.length+' records');
				if (data.length>0) {
					var results = AJS.$.parseJSON(jqXHR.responseText);	
					AJS.$('#jemh-auditevents-searchresults').html('&nbsp;&nbsp;<strong>Found '+data.length+' result(s)</strong>').fadeOut(5000, 0, function() {
						AJS.$('#jemh-auditevents-searchresults').html('').fadeIn();
				    });
				    
					displayResults(results);
				} else {
					AJS.$('#jemh-auditevents-searchresults').html('&nbsp;&nbsp;<strong>No results found</strong>').fadeOut(5000, 0, function() {
						AJS.$('#jemh-auditevents-searchresults').html('').fadeIn();
				    });					
				}
			}
		}).fail(function(data, textStatus, errorMessage) {
				console.error("executeHistorySearch("+data+") failed: "+textStatus+" : "+formUrl+", errorMessage: "+errorMessage);
			});
	}
	
    var msPerMinute = 60 * 1000;
    var msPerHour = msPerMinute * 60;
    var msPerDay = msPerHour * 24;
    var msPerMonth = msPerDay * 30;
    var msPerYear = msPerDay * 365;				
    
	function timeDifference(current, previous) {

	    var elapsed = current - previous;
	    
	    if (elapsed < msPerMinute) {
	         return Math.round(elapsed/1000) + ' seconds ago';   
	    } else if (elapsed < msPerHour) {
	    	 var val=Math.round(elapsed/msPerMinute);
	    	 if (val>1) {
	    		 return val+' minutes ago';
	    	 } else {
	    		 return 'a minute ago';
	    	 }
	            
	    } else if (elapsed < msPerDay ) {
	    	 var val=Math.round(elapsed/msPerHour);
	    	 if (val>1) {
	    		 return val+' hours ago';
	    	 } else {
	    		 return 'an hour ago';
	    	 }
	    } else if (elapsed < msPerMonth) {
	    	var val=Math.round(elapsed/msPerDay); 
	    	if (val>1) {
	    		 return 'about '+val+' days ago';
	    	 } else {
	    		 return 'about '+val+' day ago';
	    	 }
	    } else if (elapsed < msPerYear) {
	    	var val=Math.round(elapsed/msPerMonth);
	    	if (val>1) {
	    		 return 'about '+val+' months ago';
	    	 } else {
	    		 return 'about '+val+' month ago';
	    	 }
	    } else {
	    	var val=Math.round(elapsed/msPerYear );
	    	if (val>1) {
	    		 return 'about '+val+' years ago';
	    	 } else {
	    		 return 'about '+val+' year ago';
	    	 }
	    }
	}
	
	function renderLink(url, name) {
		return '<A HREF="'+url+'">'+name+'</A>';
	}
	function renderImageLink(url, name, imageName) {
		return '<A HREF="'+url+'" title="'+name+'"><IMG SRC="'+IMAGE_BASE+'/'+imageName+'"></IMG></A>';
	}
	function renderImageScriptLink(script, name, imageName) {
		return "<A HREF='#' onclick='"+script+"' title='"+name+"'><IMG SRC='"+IMAGE_BASE+"/"+imageName+"'></IMG></A>";
	}
	
	function getStatusFor(arow)
	{
		var result='';
		var filterName='';
		var filterReason='';
		var filterAction='';
		
		if (arow.filterName)
		{
			filterName=htmlEncode(arow.filterName);
		}
		if (arow.filterReason)
		{
			filterReason=htmlEncode(arow.filterReason);
		}
		if (arow.filterAction)
		{
			filterAction=htmlEncode(arow.filterAction);
		}
		
		if (arow.reprocNextId>0) {
			  var titleStr=title="Email reanimated @ "+new Date(arow.reprocDate).toLocaleTimeString()+" with Profile: #"+arow.reprocProfileId;
			  result="<table width='100%'><tr><td rowspan='2'><img src='"+IMAGE_BASE+"/reprocessed.png'/></td><td><A HREF='#' title='"+titleStr+"'><span class='aui-lozenge aui-lozenge-subtle aui-lozenge-complete'>Reprocessed</span></A></td></tr>";
			  if (arow.reprocNextId>0) {
				  result=result+"<tr><td><small>See id: "+arow.reprocNextId+"</small></td></tr>";
			  }			  
			  result=result+"</table>";
		} else if (arow.processOutcome) {			  
			if (arow.processOutcome == "canHandle") {
		    	if (arow.exception) {
		    		result="<A href='"+AJS.contextPath()+"/secure/admin/jemh/JEMHAuditing!viewDetail.jspa?id="+arow.id+"&customEditType=view-details&atl_token="+atl_token()+"' title='"+arow.exception+"'>";
		    		result=result+"<span class='aui-lozenge aui-lozenge-error'>BUG!</span></A>";		    		
				} else if (!arow.createdIssues && !arow.commentedIssues && !arow.updatedIssues ) {
	    			result="<A href='"+AJS.contextPath()+"/secure/admin/jemh/JEMHAuditing!viewDetail.jspa?id="+arow.id+"&customEditType=view-details&atl_token="+atl_token()+"' title='"+arow.exception+"'>";
	    			result=result+"<span class='aui-lozenge aui-lozenge-error'>BUG!</span></A>";
		    	} else {
		    		result="<A href='"+AJS.contextPath()+"/secure/admin/jemh/JEMHAuditing!viewDetail.jspa?id="+arow.id+"&customEditType=view-details&atl_token="+atl_token()+"' title='See Detail'>";
		    		result=result+"<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-success'>Processed</span>";
		    		// ... CHECK for HINTS
		    		if (arow.hasHints) {
		    			result=result+"<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-complete'>Hints</span>";
		    		}
		    		result=result+"</A>";
		    	}
			} else if (arow.processOutcome == "filtered" || arow.processOutcome == "drop") {
				if (arow.processOutcome == "filtered") {
					result="<A href='"+AJS.contextPath()+"/secure/admin/jemh/JEMHAuditing!viewDetail.jspa?id="+arow.id+"&customEditType=view-details&atl_token="+atl_token()+"' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'>"
					result=result+"<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-moved'>Filtered</span>";
					result=result+"</A>";
				} else {
					if (filterName)
					{
						result="<A href='#' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'>"
						result=result+"<span class='aui-lozenge aui-lozenge-subtle'>Dropped</span>";
						result=result+"</A>";
					}
					else
					{
						result=result+"<span class='aui-lozenge aui-lozenge-subtle'>Dropped</span>";
					}
				}				
			} else if (arow.processOutcome=="reject") {
				if (arow.rejectReason)
				{					
					result="<A href='#' title='Reason: "+htmlEncode(arow.rejectReason)+"'><span class='aui-lozenge aui-lozenge-subtle aui-lozenge-error'>Rejected</span></A>";
				}
				else
				{
					result="<A href='#' title='Reason: unknown'><span class='aui-lozenge aui-lozenge-subtle aui-lozenge-error'>Rejected</span></A>";
				}
			} else if (arow.processOutcome=="forward") {
	    		if ( arow.exception ) {
	    			result="<A href='"+AJS.contextPath()+"/secure/admin/jemh/JEMHAuditing!viewDetail.jspa?id="+arow.id+"&customEditType=view-details&atl_token="+atl_token()+"' title='"+htmlEncode(arow.exception)+"'><span class='aui-lozenge aui-lozenge-error'>Forwarded Exception</span></A>";
	    		} else {
	    			result="<A href='#' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'><span class='aui-lozenge aui-lozenge-subtle aui-lozenge-moved'>Forwarded</span></A>";
	    		}
			} else if (arow.processOutcome=="hold") {
				result="<A href='#' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'><span class='aui-lozenge aui-lozenge-subtle aui-lozenge-current'>On Hold</span></A>";
			} else if (arow.processOutcome=="delete") {
				result="<A href='#' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'><span class='aui-lozenge aui-lozenge-subtle'>Deleted</span></A>";
			} else {
	    		result="<span class='aui-lozenge aui-lozenge-error'>Unknown status: "+arow.processOutcome+"</span>";
			}
		}
		else {
		   result="In Progress (or BUG if never changes!)";
		}

		return result;		
	}
	
	function buildDetail(arow) {
	    var tr="<div class='jemh-detail-container'><div>";
    	tr=tr+"<div id='jemh-detail-header'><span>";    	
    	if (arow.subject) {
			if (arow.subject.length>60) {
				tr=tr+"<span title='"+htmlEncode(arow.subject)+"'>"+htmlEncode(arow.subject.substring(0,60))+" ...</span>";
			} else {
				tr=tr+htmlEncode(arow.subject);
			}    		
    	} else {
    		tr=tr+"";
    	}
    	tr=tr+"</span></div>";

    	tr=tr+"</div>";
		return tr;
	}
	
	function pollServerForAuditEvents() { 
		
		var auditHistoryPageSize=AJS.$('#jemh-auditevents-page-size option:selected').val();
		var pollUrl=AJS.contextPath()+'/rest/jemh/latest/auditing/auditevent/latest?lastReadId='+lastAuditHistoryEventLoaded+'&pageSize='+auditHistoryPageSize+'&atl_token='+atl_token();
		
		AJS.$('#jemh-auditevents-searchresults').html("Checking...");
		
		var jqXHR=AJS.$.ajax({
			type:"GET",
			dataType:"json",
			contentType: "application/json; charset=utf-8",
			url:pollUrl,								
			timeout:10000
		});
				
		jqXHR.done(function(data, textStatus, errorMessage) {
			if (data)
			{
				if(data.errors) {
					console.log('pollServerForAuditEvents() errors');	
					AJS.$('#jemh-auditevents-searchresults').html("Comms problem");
				}
				else {
					displayResults(data);
					AJS.$('#jemh-auditevents-searchresults').html("");
				}
			}
			else
			{
				AJS.$('#jemh-auditevents-searchresults').html("");
			}

			AJS.$("#auditevents-lastupdated").text(new Date().toLocaleTimeString());

		}).fail(function(data, textStatus, errorMessage) {
				console.log("Poll failed: "+textStatus+" : "+pollUrl);
				stopAutoUpdate();
				AJS.$('#jemh-auditevents-autoupdate').removeAttr('checked');
				AJS.$('#errorMessage').show();
			});
	}
	
	function restartAutoUpdate() {
		clearInterval(refreshInterval);
		refreshInterval = setInterval(pollServerForAuditEvents, AJS.$('#jemh-event-update-period').val());
	}
	
	function stopAutoUpdate() {
		clearInterval(refreshInterval);
	}
	
	function displayResults(data) {		
		var timeNow = new Date();
		var auditHistoryPageSize=AJS.$('#jemh-auditevents-page-size option:selected').val();
		var jemhDataRowCount=data.length;
		
	    for (var i=jemhDataRowCount-1 ; i>=0 ; i--)
	    {
	    	var arow=data[i];	    	 
	    	var msg='got a row - '+i+' with id: '+arow.id +" ";
	    	if (arow.createdIssues) { msg=msg+' created: '+arow.createdIssues; }
	    	if (arow.commentedIssues) { msg=msg+' commented: '+arow.commentedIssues; }
	    	if (arow.updatedIssues) { msg=msg+' updated: '+arow.updatedIssues; }
	    	if (arow.issueKey) { msg=msg+' with issueKey: '+arow.issueKey; }
	    	
	    	var tr = '<tr id="jemh-auditing-data-row_'+arow.id+'" class="jemh-auditing-data-row" >';
			var detailUrl=AJS.contextPath()+'/secure/admin/jemh/JEMHAuditing!viewDetail.jspa?id='+arow.id+'&customEditType=view-details&atl_token='+atl_token();
			
			//1
		    tr=tr+'<td><a title="View Results" href='+detailUrl+'>'+arow.id+'</a></td>';
		    
		    //2
		    tr=tr+'<td><a href="#" title="'+timeDifference(timeNow,arow.dateProcessedAsLong)+'">'+arow.dateProcessed+'</a></td>';

		    //3
		    tr=tr+'<td>';
	    	if (arow.fromAddress)
	    		tr=tr+'<small>'+arow.fromAddress+'</small>';
	    	else {
	    		tr=tr+"<strong>No Sender!</strong>";
	    	}
	    	tr=tr+'</td>';
	    		    	
		    // 4 Details
		    tr=tr+'<td>';
		    tr=tr+buildDetail(arow);
		    tr=tr+'</td>';

		    // 5
		    tr=tr+'<td>';
		    if (arow.attachmentCount>0) {
		    	tr=tr+arow.attachmentCount;
		    }
		    tr=tr+'</td>';
		    
		    //6
		    tr=tr+'<td>';
		    if (typeof(arow.createdIssues) != "undefined" && arow.createdIssues.length>0) {
		    	tr=tr+'<small>Created: ';
		    	if (arow.createdIssues.length<=1) {
		    		tr=tr+'</small>';
		    	}
		    	for (j = 0; j < arow.createdIssues.length; j++) { 
		    		tr=tr+renderLink(AJS.contextPath()+'/browse/'+arow.createdIssues[j], arow.createdIssues[j])+'</A> ';
		    	}
		    	if (arow.createdIssues.length>1) {
		    		tr=tr+'</small>';
		    	}		    	
		    	
		    } else if (typeof(arow.commentedIssues) != "undefined" && arow.commentedIssues.length>0) {
		    	tr=tr+'<small>Commented: ';
		    	if (arow.commentedIssues.length<=1) {
		    		tr=tr+'</small>';
		    	}		    	
		    	for (j = 0; j <  arow.commentedIssues.length; j++) { 
		    		tr=tr+renderLink(AJS.contextPath()+'/browse/'+ arow.commentedIssues[j],  arow.commentedIssues[j])+'</A> ';
		    	}
		    	if (arow.commentedIssues.length>1) {
		    		tr=tr+'</small>';
		    	}		    	
		    } else if (typeof(arow.updatedIssues) != "undefined" && arow.updatedIssues.length>0) {
		    	tr=tr+'<small>Updated: ';
		    	if (arow.updatedIssues.length<=1) {
		    		tr=tr+'</small>';
		    	}		    	
		    	for (j = 0; j < arow.updatedIssues.length; j++) { 
		    		tr=tr+renderLink(AJS.contextPath()+'/browse/'+arow.updatedIssues[j], arow.updatedIssues[j])+'</A> ';
		    	}
		    	if (arow.updatedIssues.length>1) {
		    		tr=tr+'</small>';
		    	}		    	
		    }
		    tr=tr+'</td>';
		    
			//7
			tr=tr+'<td>';
			tr=tr+getStatusFor(arow);
		    tr=tr+'</td>';
		    
		    //8		
		    
		    tr=tr+"<td><div class='jemh-auditevent-options' id='options_"+arow.id+"' style='display:none;'>";

		    tr=tr+renderImageScriptLink("popupEmailDetail(event,"+arow.id+");", "Popup Email Detail", "gmail-icon16.png");
		    tr=tr+"&nbsp;"		    

		    if (arow.profileId>0) {
		    	tr=tr+renderImageLink(AJS.contextPath()+'/secure/admin/jemh/JEMHConfiguration!view.jspa?profileId='+arow.profileId+'&atl_token='+atl_token(), 'Configure Profile #'+arow.profileId, 'configuration-icon16x16.png');
		    	tr=tr+"&nbsp;"
		    }
		    
		    tr=tr+renderImageLink(detailUrl, 'Processing Detail', 'properties.gif');
		    tr=tr+"&nbsp;"					    
		    
		    tr=tr+renderImageLink(AJS.contextPath()+'/secure/admin/jemh/JEMHTestCases!createFromAuditEvent.jspa?auditEventId='+arow.id+'&atl_token='+atl_token(), 'Create a Test Case', 'editor.gif');
		    tr=tr+"&nbsp;"
		    
		    if (arow.preprocessed) {
		    	tr=tr+renderImageLink(AJS.contextPath()+'/secure/admin/jemh/JEMHAuditing!downloadMail.jspa?id='+arow.id+'&atl_token='+atl_token(), 'Export Post-Processed email', 'export_wiz_modified.gif');
		    	tr=tr+"&nbsp;"
		    }
		    
		    tr=tr+renderImageLink(AJS.contextPath()+'/secure/admin/jemh/JEMHAuditing!downloadMail.jspa?id='+arow.id+'&getOriginal=on&atl_token='+atl_token(), 'Export Original Un-Processed email', 'export_wiz.gif');
		    tr=tr+"&nbsp;"
		    
		    if (arow.profileId>0) {
		    	tr=tr+renderImageScriptLink("reprocess(event,"+arow.id+");", 'Reprocess', 'run-reprocess.png');
		    	tr=tr+"&nbsp;"
		    }
		    
		    tr=tr+"&middot; "
		    tr=tr+renderImageLink(AJS.contextPath()+'/secure/admin/jemh/JEMHAuditing!delete.jspa?id='+arow.id+'&atl_token='+atl_token(), 'Delete', 'trash.gif');
		    tr=tr+'</div></td>';
			 
	    	while ( AJS.$("#jemh-auditevents-table > tbody > tr").length >=auditHistoryPageSize )
	    	{
	    		AJS.$("#jemh-auditevents-table > tbody > tr:last").remove();
			}

			tr=tr+'</tr>';
			//.not(':first')
			AJS.$(tr).prependTo("#jemh-auditevents-table > tbody");
			var theRow="#jemh-auditing-data-row_"+arow.id;
			AJS.$(theRow).hover(
			  function () {
			    AJS.$(this).css("background","#f0f0f0");
			    AJS.$(this).find('.jemh-auditevent-options').show();
			  },
			  function () {
			    AJS.$(this).css("background","");
			    AJS.$(this).find('.jemh-auditevent-options').hide();
			  }
			);
			
			if (arow.id>lastAuditHistoryEventLoaded)
			{
				lastAuditHistoryEventLoaded=arow.id;
			}						
		}
	}
	
	function checkPurgeMatches()
	{
		disableAuditPurgeButton();
		cleanPurgeDataFields();
		var jqXHR=AJS.$.ajax({
			type:"GET",
			dataType:"json",
			contentType: "application/json; charset=utf-8",
			url:AJS.contextPath()+"/rest/jemh/1.0/auditing/purge/checkmatches?atl_token=" + atl_token(),
			timeout:15000});
		
		jqXHR.done(function(data, textStatus, errorMessage) {
			enableAuditPurgeButton();
			
			var msg=data.matches;			
			if (data.totalCount>0)
			{
				msg=msg+' of '+data.totalCount+" ("+Math.round(100*data.matches/data.totalCount)+"%)";
			}
			msg=msg+" - before "+data.fromDateTime;

			AJS.$('#jemhAuditPurgeEventsFoundInRange').text(msg);
		}).fail(function(data, textStatus, errorMessage) {
			enableAuditPurgeButton();
			console.log("Purge CHECK failed: "+textStatus+", status: "+jqXHR.status+"response: "+jqXHR.responseText);
		});
	}
	
	AJS.$('#auditingPurgeCheckMatchesButton').click(function(event) {
		checkPurgeMatches();
		
    });	
	
	AJS.$('#auditingPurgeManualPurgeButton').click(function(event) {
		disableAuditPurgeButton();
		cleanPurgeDataFields();
		var jqXHR=AJS.$.ajax({
			type:"GET",
			dataType:"json",
			contentType: "application/json; charset=utf-8",
			url:AJS.contextPath()+"/rest/jemh/1.0/auditing/purge/run?atl_token=" + atl_token(),
			timeout:15000});
		
		jqXHR.done(function(data, textStatus, errorMessage) {
			checkPurgeStatus();
		}).fail(function(data, textStatus, errorMessage) {
			alert("Purge RUN failed: "+textStatus);
			enableAuditPurgeButton();
		});
    });	

	// pollServerForAuditEvents();
	// var refreshInterval = setInterval(pollServerForAuditEvents, AJS.$('#jemh-event-update-period option:selected').val());
	//
	// //AJS.I18n.getText("jemh.common.operations")
    //
    // checkPurgeMatches();
});
