AJS.$(document).ready( function(){
	var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();

	console.log('edit-workflow-rule.js loaded')
	
	function setupStatusesFor(workflowName) {
		console.log('setting up statuses for workflow: ['+workflowName+']');
		
		var dataUrl = baseUrl+'/rest/jemh/latest/workflow/rule/statuses?wfname='+encodeURIComponent(workflowName);
		AJS.$.getJSON(dataUrl, {atl_token: atl_token()}, function (results) {
			for (var i=0 ; i<results.length; i++) {
				//console.log('adding option id='+results[i].id+', name='+results[i].name);
				AJS.$("#statuses").append(AJS.$("<option>", {
						value: results[i].id, text: results[i].name + " (id="+results[i].id+")"
					}));
			}

			var initialWorkflowName=AJS.$("input[name=initialWorkflowName]").val();
			if(initialWorkflowName === workflowName)
			{
				AJS.$("[name=initialStatusCSV]").each(function() {
					var val=AJS.$( this ).attr('value');
					console.log('*** setting workflow Statuses : '+val);
					var selectedStatuses = val.split(",");
					for (var i=0; i<selectedStatuses.length; i++)
					{
						var selector="#statuses option[value='"+selectedStatuses[i]+"']";
						AJS.$(selector).attr('selected',"selected");
					}
				});
			}
	    });
	}
	function setupTransitionsFor(workflowName) {
		console.log('setting up transitions for workflow: ['+workflowName+']');
	
		var dataUrl = baseUrl+'/rest/jemh/latest/workflow/rule/transitions?wfname='+encodeURIComponent(workflowName);
		AJS.$.getJSON(dataUrl, {atl_token: atl_token()}, function (results) {
			for (var i=0 ; i<results.length; i++) {
				//console.log('adding option id='+results[i].id+', name='+results[i].name);
				AJS.$("#select_transitions").append(AJS.$("<option>", {
						value: results[i].id, text: results[i].name + " (id:"+results[i].id+")"
					}));
			}
	    });
	}

	function setupIssueTypesFor(workflowName, projectKey) {
		console.log('setting up issue types for workflow: ['+workflowName+']');

		var dataUrl = baseUrl+'/rest/jemh/latest/workflow/rule/issueTypes?wfname='+encodeURIComponent(workflowName)+'&projectKey='+encodeURIComponent(projectKey);
		AJS.$.getJSON(dataUrl, {atl_token: atl_token()}, function (results) {
			for (var i=0 ; i<results.length; i++) {
				console.log('adding issueType option value:' + results[i]);
				AJS.$("#workflowIssueTypes").append(AJS.$("<option>", {
					value: results[i], text: results[i]
				}));
			}

			var initialWorkflowName=AJS.$("input[name=initialWorkflowName]").val();
			if(initialWorkflowName === workflowName)
			{
				AJS.$("[name=initialIssueTypesCSV]").each(function() {
					var val=AJS.$( this ).attr('value');
					console.log('*** setting workflow issue types : '+val);
					var selectedIssueTypes = val.split(",");
					for (var i=0; i<selectedIssueTypes.length; i++)
					{
						var selector="#workflowIssueTypes option[value='"+selectedIssueTypes[i]+"']";
						AJS.$(selector).attr('selected',"selected");
					}
				});
			}
		});
	}
	
	function setupStatusOptions()
	{
		console.log('setupWorkflowOptions()');

		AJS.$("#statuses option:selected").removeAttr("selected");
		AJS.$("#statuses option").remove();
		AJS.$("#s2id_select_transitions .select2-search-choice").remove();
		AJS.$("#statuses").empty();
		
		var workflowName=AJS.$("#workflowName option:selected").text();
		setupStatusesFor(workflowName);
		

	}

	function setupIssueTypesOptions()
	{
		console.log('setupWorkflowOptions()');

		AJS.$("#workflowIssueTypes option:selected").removeAttr("selected");
		AJS.$("#workflowIssueTypes option").remove();
		AJS.$("#workflowIssueTypes").empty();
		var workflowName=AJS.$("#workflowName option:selected").text();
		var projectKey=AJS.$('input[name="projectKey"]').attr('value');
		setupIssueTypesFor(workflowName, projectKey);
	}
	
	function setupTransitionOptions()
	{
		console.log('setupTransitionOptions()');
		
		AJS.$("#select_transitions option:selected").removeAttr("selected");
		AJS.$("#select_transitions option").remove();
		AJS.$("#transitions").empty();
		
		var workflowName=AJS.$("#workflowName option:selected").text();
		setupTransitionsFor(workflowName);
	}

	function saveTransitionsInHiddenInput()
	{
		console.log('saveTransitionsInHiddenInput()');
		
		var data = AJS.$("#select_transitions").select2('data');
		var array = [];
		AJS.$.each(data, function(index, val) {
	    	//console.log('adding transitionId: '+val.id);
	        array[index]=val.id;
	    });
		array.join(',');

		//console.log('setting transition input val: '+array);
	    AJS.$("input[name=transitions]").val( array );
	}
	
	function hookSelect2Change() {
		console.log('hookSelect2Change()');
		AJS.$("#select_transitions").on('change', function(){
			saveTransitionsInHiddenInput();
		});
	}
	
	function hookRunAsConditionChange() {
		console.log('hookRunAsConditionChange()');
		if (AJS.$("#runAsCondition").val()=='nominatedUserOnly') {
			AJS.$(".run-as-group").show(500);
		} else {
			AJS.$(".run-as-group").hide(500);
		}
		
		AJS.$("#runAsCondition").change(function() {
			if (AJS.$(this).val()=='nominatedUserOnly') {
				AJS.$(".run-as-group").show(500);
			} else {
				AJS.$(".run-as-group").hide(500);
			}
		});
	}

	function hookWorkflowNameChange() {
		console.log('hookWorkflowNameChange()');
		AJS.$("#workflowName").change(function(){
			setupStatusOptions();
			setupTransitionOptions();
			setupIssueTypesOptions()
		});
	}
	
	function initialize() {
		hookWorkflowNameChange();		
		hookSelect2Change();
		hookRunAsConditionChange();
		AJS.$("#select_transitions").auiSelect2();
		saveTransitionsInHiddenInput();
	}
	
	initialize();
});