AJS.$(document).ready(function () {
    let paramsValid = true;

    function prepareOnEventActions() {

        AJS.$("#createKeywordRuleButton").on("click", function () {
            AJS.dialog2("#addKeywordRuleDialog").show();
        });

        AJS.$("#createKeywordRuleCancelButton").on("click", function () {
            AJS.dialog2("#addKeywordRuleDialog").hide();
        });

        AJS.$("#submitCreateKeywordRule").on("click", function () {
            paramsValid = true;

            let projectKey = AJS.$("#projectKey").val()
            let profileId = AJS.$("#profileId").val();

            let projectKeywordMapping = AJS.$('#projectKeywordMapping').val();

            if (paramsValid) {
                console.log("Validating profileId... value is: " + profileId);
                paramsValid = validateParam(profileId);
            }

            if (paramsValid) {
                console.log("Validating projectKey... value is: " + projectKey);
                paramsValid = validateParam(projectKey);
            }

            if (paramsValid) {
                console.log("Validating projectKeywordMapping... value is: " + projectKeywordMapping);
                paramsValid = validateParam(projectKeywordMapping);
            }

            if (paramsValid) {
                submitCreateNewKeywordRule();
            } else {
                console.error("One of your parameters is invalid.")
            }
        });
    }

    AJS.$("#projectKeywordMapping").on('keyup', function () {
        submitChecker();
    });

    function submitChecker() {
        let emptyValue = true;
        let keyWordRule = AJS.$('#projectKeywordMapping').val();

        if (keyWordRule === null || keyWordRule === undefined || keyWordRule === "") {
            emptyValue = false;
        }

        if (emptyValue) {
            AJS.$("#submitCreateKeywordRule"). attr("disabled", false);
        } else {
            AJS.$("#submitCreateKeywordRule"). attr("disabled", true);
        }
    }

    function submitCreateNewKeywordRule() {
        var postData = AJS.$('#jemhKeywordRulePopupForm').serialize();
        var formUrl = AJS.$('#jemhKeywordRulePopupForm').attr('action');

        //contentType: sent to the server as a header
        //dataType is the response
        var jqXHR = AJS.$.ajax({
            type: "POST",
            url: formUrl,
            data: postData,
        }); //post

        jqXHR.done(function (data, textStatus, errorThrown) {
            // On success hide the dialog and then refresh the page to view the new PM
            AJS.dialog2("#addKeywordRuleDialog").hide();
            location.reload();

        }).fail(function (data, textStatus, errorMessage) {
            // Provide info if the Project Mapping couldn't be created
            window.alert("Error when creating Project Mapping!");
            AJS.dialog2("#addKeywordRuleDialog").hide();
        });
    }

    function validateParam(param) {
        let result = true;
        if (param === null || param === undefined || param === "" || param === "(none)") {
            console.log("param: " + param + " is invalid");
            result = false;
        }
        return result;
    }

    prepareOnEventActions();
});