AJS.$(document).ready( function()
{
	console.log('pmrule.js loaded');

	function runScript(editor, editWrapperDivId, consoleLogDiv) {
		AJS.$("#evalInfo").hide();
		AJS.$(consoleLogDiv).css({border: "3px solid #CCCCCC"});
	  	AJS.$(consoleLogDiv).text("Running, please wait...");
	  	//AJAX POST of content to render
	  	
	  	let languageEngine = AJS.$("#jemhProjectScriptMappingForm [name=scriptLanguage]").val();
	  	let currentLanguage =languageEngine.split("_")[0];
		let currentEngine = "";
		if (languageEngine.length > 1) {
			currentEngine =languageEngine.split("_")[1];
		}
	  	console.log('currentLanguage: '+currentLanguage);
		console.log('currentEngine: '+currentEngine);
		
	  	var currentScript = editor.getSession().getValue();
	  	//console.log('currentScript: '+currentScript);
	  	
		var	currentTestCaseId = AJS.$("#testCasePicker").val();
		console.log('testCaseId: '+currentTestCaseId);
		
		if(!currentTestCaseId) 
		{
			console.log('No test case selected');
  			AJS.$('#ruleValidationStatus').removeClass('aui-lozenge-success').addClass('aui-lozenge-error').text('NO TEST CASE SELECTED');
  			AJS.$(consoleLogDiv).empty();
  			return;
		}
		
		AJS.$("#jemhScriptDataForm [name=testCaseId]").val(currentTestCaseId);
	  	AJS.$("#jemhScriptDataForm [name=scriptContent]").val(currentScript);
	  	AJS.$("#jemhScriptDataForm [name=scriptLanguage]").val(currentLanguage);
	  	AJS.$("#jemhScriptDataForm [name=scriptEngine]").val(currentEngine);

		var postData=AJS.$('#jemhScriptDataForm').serialize();
		var formUrl = AJS.$('#jemhScriptDataForm').attr('action');
	  	
		//contentType: sent to the server as a header
		//dataType is the response
		var jqXHR=AJS.$.ajax({
			type:"POST",
			url: formUrl,
			dataType:"json",
			data:postData,
			timeout:60000
		}); //post
												  	
	  	jqXHR.done(function(data, textStatus, errorThrown) {
			AJS.$("#evalInfo").show();
			
	  		AJS.$("#mailProcessingDuration > div").text(data.duration+" ms [engineInit="+data.scriptEngineInitTime
	  			+"ms,  scriptCompile="+data.scriptCompileTime
	  			+"ms, scriptEval="+data.scriptEngineEvalTime+"ms]").html();
	  		
	  		if (data.exception)
	  		{
				AJS.$(consoleLogDiv).css({border: "3px solid #DE350B"});
	  			AJS.$('#ruleValidationStatus').removeClass('aui-lozenge-success').addClass('aui-lozenge-error').text('ERROR');
	  			AJS.$(consoleLogDiv).text(data.exception);
	  		}
	  		else 
	  		{
				AJS.$(consoleLogDiv).css({border: "3px solid #00875A"});

	  			if (data.consoleLog)
	  			{
	  				console.log('consoleLog: '+data.consoleLog);
		  			AJS.$(consoleLogDiv).text(data.consoleLog);
		  		}
	  			else
	  			{
	  			  	AJS.$(consoleLogDiv).text("Script returned no console output");
	  			}

				if (data.map)
				{
					AJS.$('#scriptMapResultTable tbody').find("tr").remove();
					AJS.$('#scriptMapResultTable tbody').append('<tr><th colspan="2" style="background-color: lightgray;">Default Result</th></tr>');
					for (var key in data.map) {
						var attrName = key;
						var attrValue = data.map[key];
						console.log('mapped ' + attrName + ' = ' + attrValue);
						var row = '<tr><th>' + htmlEncode(attrName) + '</th><td>' + htmlEncode(attrValue) + '</td></tr>';
						AJS.$('#scriptMapResultTable tbody').append(row);
					}
				}
				
				if (data.additionalResultSets)
				{
					console.log('additional result sets there');
					for(var i = 0; i < data.additionalResultSets.length; i++)
					{
						console.log('processing idx '+i);
						var obj = data.additionalResultSets[i];
						AJS.$('#scriptMapResultTable tbody').append('<tr><th colspan="2" style="background-color: lightgray;">Additional Result '+(i+1)+'</th></tr>');
						for (var key in obj) {
							var attrName = key;
							var attrValue = obj[key];
							console.log('mapped result['+i+'] ' + attrName + ' = ' + attrValue);
							
							var openpre='';
							var closepre='';
							if(attrName == 'comment')
							{
								openpre='<pre>';
								closepre='</pre>';
							}			

							var row = '<tr><th>' + htmlEncode(attrName) + '</th><td>' + openpre + htmlEncode(attrValue) + closepre + '</td></tr>';
							AJS.$('#scriptMapResultTable tbody').append(row);
						}
					}
				}

	  			if (data.match===true) {
	  				AJS.$('#ruleValidationStatus').removeClass('aui-lozenge-error').addClass('aui-lozenge-success').text('RULE MATCH');
	  			} else {
	  				AJS.$('#ruleValidationStatus').removeClass('aui-lozenge-success').addClass('aui-lozenge-error').text('NO RULE MATCH');
	  			}
		  	}
	  			
	  	}).fail(function(data, textStatus, errorMessage) {
	  		console.log('fail');
			console.log("Script execution failed: textStatus="+textStatus+", errorMessage: "+errorMessage);
			AJS.$(consoleLogDiv).text('');
			AJS.messages.generic(consoleLogDiv, {
			   title:"Script rendering failed",
			   body: '<p>Status: '+textStatus+', error: '+errorMessage+'</p>'
			});			
	  	});
	}

	try {
		var scriptEditor = buildAceEditor('jemhProjectScriptMappingForm', 'editor0', 'statusBar', 'scriptContent', 'javascript');

		AJS.$("form [name=ruleMatchButton]").click(function(e) {
			e.preventDefault();
			runScript(scriptEditor, "#editor0", "#ruleValidationConsole");
			return false;
		}); //click
	}catch(e){
		console.error('Ace Editor Exception: '+e, e);
	}

	//Script Language
	AJS.$(".jemhScriptRuleLanguage").change(function(){
		let languageValEngineVal = AJS.$(".jemhScriptRuleLanguage").find(":selected").val();
		if(languageValEngineVal){
			let engineVal = "";
			let languageVal = languageValEngineVal.split("_")[0];
			if (languageValEngineVal.length > 1) {
				engineVal = languageValEngineVal.split("_")[1];
			}
			AJS.$("#scriptLanguage").text(languageVal);
			AJS.$("#scriptEngine").text(engineVal);
			checkEngineAndLanguageValidation(languageVal, engineVal);
		}
	});

	let languageValEngineVal = AJS.$(".jemhScriptRuleLanguage").find(":selected").val();
	if(languageValEngineVal){
		let engineVal = "";
		let languageVal = languageValEngineVal.split("_")[0];
		if (languageValEngineVal.length > 1) {
			engineVal = languageValEngineVal.split("_")[1];
		}
		checkEngineAndLanguageValidation(languageVal, engineVal);
	}

	loadScriptContext('scriptrule');

	if(AJS.$("#autoJoinGroupsAudience")){
		AJS.$("#autoJoinGroupsAudience").change(function(e){
			hideOrShowIncludeNewUsersSelect();
		});
		hideOrShowIncludeNewUsersSelect();
	}
});

function checkEngineAndLanguageValidation(languageVal, engineVal) {
	//Is Language compatible
	if(engineVal !== "" && languageVal !== ""){
		AJS.$('#ruleLanguageStatus').hide();
	}
	if (!engineVal) {
		AJS.$('#ruleLanguageStatus').removeClass('aui-lozenge-success').removeClass('aui-lozenge-error').text('No Engine Found');
		AJS.$('#ruleLanguageStatus').show();
	}
	if (!languageVal) {
		AJS.$('#ruleLanguageStatus').removeClass('aui-lozenge-success').removeClass('aui-lozenge-error').text('No Language Found');
		AJS.$('#ruleLanguageStatus').show();
	}
}

function hideOrShowIncludeNewUsersSelect(){
	let audience = AJS.$("#autoJoinGroupsAudience").find(":selected").val();
	if(audience !== null){
		let reporterVal = "SENDER";
		let includeNewUserSelect = AJS.$("#includeNewUsers");
		if(audience === reporterVal){
			includeNewUserSelect.parent().hide(500);
		}else{
			includeNewUserSelect.parent().show(500);
		}
	}
}
