AJS.$(document).ready(function() {	
	console.log('JEMH Postfunction script is running');
	
	var baseUrl=AJS.$('input[name="jemhBaseUrl"]').val();	
	var formUrl = baseUrl + '/rest/jemh/latest/templateset/preview';
	var jemhAtlToken=AJS.$('input[name="jemhAtlToken"]').val(); // AJS.$("meta[name='atlassian-token']").attr('content')
    var aceLoaded=false;
    var subjectEditor;
    var contentEditor;
    var mailHeaderScriptEditor;
    
    var transportNeedsSubject=true;
    var transportNeedsContent=true;
    
    //
    // dynamically add form to postfunction screen body after jemh postfunction has run, as all jemh postfunction content is 'in' a form, so can't be used for serialization otherwise 
    //
    function addDyamicallyGeneratedFormToBody() {
    	AJS.$(document.body).append('<div name="jemhPreviewDiv" style="visibility: hidden;"/>');    	
    	AJS.$("div[name='jemhPreviewDiv']").append('<form name="jemhPreviewForm" action="jemhPreview" method="POST">');
    	AJS.$("form[name='jemhPreviewForm']").append('<input type="text" name="atl_token" id="atl_token"/>');
    	AJS.$("form[name='jemhPreviewForm']").append('<input type="text" id="testIssueKey" name="testIssueKey"/>');
    	AJS.$("form[name='jemhPreviewForm']").append('<input type="text" id="contentCssStyle" name="contentCssStyle"/>');
    	AJS.$("form[name='jemhPreviewForm']").append('<input type="text" id="contentToRenderMarkup" name="contentToRenderMarkup"/>');
    	AJS.$("form[name='jemhPreviewForm']").append('<input type="text" id="contentToRenderType" name="contentToRenderType"/>');
    	AJS.$("form[name='jemhPreviewForm']").append('<textarea id="contentToRender" name="contentToRender"/>');
    }

    function htmlEncode(value){
      var encoded=AJS.$('<div/>').text(value).html();
      return encoded;
    }

    function htmlDecode(value){
      return AJS.$('<div/>').html(value).text();
    }
    
    //
    // Custom subject/content preview
    //
	function showCustomContentPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs) {
	  	AJS.$(editWrapperDivId).hide();
	  	AJS.$(previewWrapperDivId).show();
	  	AJS.$(previewWrapperDivId).text("Rendering, please wait...");
		
	  	var issueKey=AJS.$("#issueKey").val();
	  		  	
	  	var contentToRenderMarkup='velocity';
	  	if (editor==contentEditor)
	  	{
	  		var selectedVal=AJS.$("#customContentMarkup option:selected").val();
	  		contentToRenderMarkup=selectedVal;
	  	}
	  	
	  	var content=editor.getSession().getValue();
	  	
	  	AJS.$("form[name='jemhPreviewForm'] #atl_token").val(jemhAtlToken);
	  	AJS.$("form[name='jemhPreviewForm'] #testIssueKey").val(issueKey);
	  	AJS.$("form[name='jemhPreviewForm'] #contentToRender").val(content);
	  	AJS.$("form[name='jemhPreviewForm'] #contentCssStyle").val(0);
	  	AJS.$("form[name='jemhPreviewForm'] #contentToRenderMarkup").val(contentToRenderMarkup);
	  	AJS.$("form[name='jemhPreviewForm'] #contentToRenderType").val(showTypeAs);
	  	
		var postData=AJS.$("form[name='jemhPreviewForm']").serialize();

		// contentType: sent to the server as a header
		// dataType is the response
		var jqXHR=AJS.$.ajax({
			type:"POST",
			url:formUrl,			
			dataType:"text",
			data:postData,
			timeout:60000
		}); // post
		
	  	jqXHR.done(function(data, textStatus, errorThrown) {
	  		if (editor==subjectEditor)
	  		{
	  			var oneline=data.replace(/(\r\n|\n|\r)/gm," ");
	  			AJS.$(previewWrapperDivId).html(AJS.escapeHtml(oneline)); //quote to stop
	  		}
	  		else
	  		{
	  			if (showTypeAs=='text') {
	  				AJS.$(previewWrapperDivId).html(AJS.escapeHtml(data));
	  			} else {
	  				AJS.$(previewWrapperDivId).html(data);
	  			}
	  		}
	  			
	  	}).fail(function(data, textStatus, errorMessage) {
			console.error("RUN fail: textStatus="+textStatus+", errorMessage: "+errorMessage);
			AJS.messages.error(previewWrapperDivId, {
			   title:"Custom Context Demo",
			   body: '<p>Run failed, status: '+textStatus+', error: '+errorMessage+'</p>'
			});			
	  	});  	
	}
	
	function showEditor(editWrapperDivId, previewWrapperDivId) {
	  	AJS.$(previewWrapperDivId).hide();
	  	AJS.$(editWrapperDivId).show();
	  	AJS.$(previewWrapperDivId).text("");
	  	AJS.$("#contentToRender").val("");
	}
	
	function updateTransportConfigSelection(transportKey)
	{
			AJS.$("#transportConfigId").attr('disabled', 'disabled');
			AJS.$.ajax({
				type:"GET",					
				url:baseUrl+"/rest/jemh/latest/transport/config/list/"+transportKey+"?atl_token="+jemhAtlToken,
				format: "json",
				success: function(data, textStatus, errorMessage) {				
					if(data.errors) {
						console.error('getStatus() errors');
					}
					else {
						AJS.$('#transportConfigId').find('option').remove().end();
						AJS.$('#transportConfigId')[0].options.length = 0;
						AJS.$(data.configurations).each(function(index) {
							var id=this.configId;
							var description=this.description;
							AJS.$('#transportConfigId').append('<option value="' + id + '">'+description+"</option>");
						});
						AJS.$("#transportConfigId").removeAttr('disabled', 'disabled');
						
						transportNeedsSubject=data.useSubject;
						if (data.useSubject)
						{
							AJS.$(".jemh-custom-subject-div").show();
						}
						else
						{
							AJS.$(".jemh-custom-subject-div").hide();
						}
						
						transportNeedsContent=data.useSubject;
						if (data.useContent)
						{
							AJS.$(".jemh-custom-content-div").show();
						}
						else
						{
							AJS.$(".jemh-custom-content-div").hide();
						}
					}
				},
				error: function(xhr, errorType, exception) {
					console.log('errorType: '+errorType+', ex: '+exception);
					var errorMessage = exception || xhr.statusText;  
			        AJS.messages.error("#jemh-message-bar", {
			        	title: "Error!", 
			          	body: "Could not get Transport Configuration List for "+transportKey+": <b>"+errorMessage+"</b>"
			        });
			        AJS.$("#transportConfigId").removeAttr('disabled', 'disabled');
			    }							
		    });
	}

	function setupVisibleFields() {
		var selectedTransportKey = AJS.$("#transportKey").find(":selected").val();
		if (selectedTransportKey=="default-email")
		{			
			AJS.$("#jemhEmailSpecificFields").show();
			AJS.$(".jemh-email-specific-content").show();
			AJS.$(".jemh-transport-specific-fields").hide();
		}
		else
		{
			updateTransportConfigSelection(selectedTransportKey);
			AJS.$("#jemhEmailSpecificFields").hide();
			AJS.$(".jemh-email-specific-content").hide();
			AJS.$(".jemh-transport-specific-fields").show();
		}
		
		var selectedTemplateId=AJS.$("#adHocTemplate").find(":selected").val();
		if (selectedTemplateId=="0")
		{
			AJS.$(".custom-jemh-content").show();
			AJS.$("#velocity-context-div").show();
			AJS.$("#templateset-preview-div").hide();
		}
		else
		{
			AJS.$(".custom-jemh-content").hide();
			AJS.$("#velocity-context-div").hide();
			AJS.$("#templateset-preview-div").show();
		}
		
		applyAddCommentFieldVisibility();
	}
	
	function setupVisibleAttachmentSourceFields() {
		var selectedAttachmentMethod=AJS.$("#attachmentSelectionMethod").find(":selected").val();
		switch (selectedAttachmentMethod) {
			case 'none':
				AJS.$('.att-src-transiton-div').hide();
				AJS.$('.att-src-recent-div').hide();
				AJS.$('.att-src-filter-div').hide();
				break;
			case 'transition':
				AJS.$('.att-src-transiton-div').show();
				AJS.$('.att-src-recent-div').hide();
				AJS.$('.att-src-filter-div').hide();
				break;
			case 'recent':
				AJS.$('.att-src-recent-div').show();				
				AJS.$('.att-src-filter-div').show();
				AJS.$('.att-src-transiton-div').hide();
				break;
			case 'all':
				AJS.$('.att-src-filter-div').show();
				AJS.$('.att-src-recent-div').hide();
				AJS.$('.att-src-transiton-div').hide();
				break;
			default:
				console.error('setupVisibleAttachmentSourceFields() unknown attachment selector: '+selectedAttachmentMethod);
				AJS.$('.att-src-transiton-div').hide();
				AJS.$('.att-src-recent-div').hide();
				AJS.$('.att-src-filter-div').hide();
		}
	}
	
	function updateVeloWikiHelpLinkVisibility() {
		if (AJS.$("#customContentMarkup option:selected").val()=='wiki') {
			AJS.$('.wikimarkup-help-link').show();
			AJS.$('.velocitymarkup-help-link').hide();
		} else if (AJS.$("#customContentMarkup option:selected").val()=='velocity') {
			AJS.$('.velocitymarkup-help-link').show();
			AJS.$('.wikimarkup-help-link').hide();
		} else if (AJS.$("#customContentMarkup option:selected").val()=='velowiki') {
			AJS.$('.velocitymarkup-help-link').show();
			AJS.$('.wikimarkup-help-link').show();
		}
	}
	
	function loadAce(initMethod) {
		AJS.$.getScript( baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace/ace.js" )
		  .done(function( script, textStatus ) {
		     
		     //https://groups.google.com/forum/#!topic/ace-discuss/2tXbbF9MCMY -->
		     ace.config.set("basePath", baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace");
		     
		     AJS.$.getScript( baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace/ext-spellcheck.js" )
		     .done(function( script, textStatus ) {
		    	 //success
		     })
		     .fail(function( jqxhr, settings, exception ) {
		       console.error( "custom ext-spellcheck.js script could not be downloaded" );
		     });
		     
			 AJS.$('<link>')
			  .appendTo('head')
			  .attr({type : 'text/css', rel : 'stylesheet'})
			  .attr('href', baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace-editor.css");
			 
			 AJS.$.getScript( baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace-editor.js" )
			  .done(function( script, textStatus ) {
			     aceLoaded=true;
			     initMethod();
			  })
			  .fail(function( jqxhr, settings, exception ) {
			    console.error( "custom ace-editor.js script could not be downloaded" );
			 });
		  })
		  .fail(function( jqxhr, settings, exception ) {
		    console.error( "ace.js could not be downloaded" );
		});
	}
	
	function clearTemplateSetPreview() {
		AJS.$('#tsPreview-subject-preview-wrapper').empty().text('...');
		AJS.$('#tsPreview-content-preview-wrapper').empty().text('...');
		AJS.$('#tsPreview-css-source').attr('style','aui-lozenge aui-lozenge-subtle').text('?');
	}
	
	function refreshTemplateSetPreview(issueKey) {
		AJS.$('#tsPreview-subject-preview-wrapper').empty().text('Loading...');
		AJS.$('#tsPreview-content-preview-wrapper').empty().text('Loading...');		
		var contentType=AJS.$('#contentType').val();					
		var customContentMarkup=AJS.$('#customContentMarkup').val();
		var currentSelectedValue=AJS.$("#adHocTemplate").find(":selected").val();
		
		if (currentSelectedValue!="0") {
			var templateSetUrl=baseUrl+'/rest/jemh/latest/templateset/download/'+currentSelectedValue+'?atl_token='+jemhAtlToken;
			var jqXHR=AJS.$.getJSON(templateSetUrl, {
					format: "json"
			});
			
			jqXHR.done(function(data, textStatus, errorMessage) {	
				if(data.errors) {
					console.error('getTemplateSet(id='+currentSelectedValue+') '+currentSelectedValue+', errors');					
				} else {
					if (data.detail) {
						console.error('Unable to download templateSet '+currentSelectedValue);
					} else {
						previewTemplateSetContent(issueKey, data.subject, true, -1, 'velocity', 'text', '#tsPreview-subject-preview-wrapper');
						
						AJS.$('#jemhTemplateCssStyle').val(data.cssStyleSource);
						if (data.cssStyleSource=='-1') {
							AJS.$('#tsPreview-css-source').attr('style','aui-lozenge aui-lozenge-subtle').text('CSS: None');
						} else if (data.cssStyleSource=='0') {
							AJS.$('#tsPreview-css-source').attr('style','aui-lozenge aui-lozenge-subtle aui-lozenge-current').text('CSS: JIRA Default');
						} else {
							AJS.$('#tsPreview-css-source').attr('style','aui-lozenge aui-lozenge-subtle aui-lozenge-current').text('CSS: Custom id='+data.cssStyleSource);
						}
						
						if (contentType=='text') {
							previewTemplateSetContent(issueKey, data.text, false, -1, 'velocity', 'text', '#tsPreview-content-preview-wrapper');
						} else {
							previewTemplateSetContent(issueKey, data.html, false, data.cssStyleSource, 'velocity', 'html', '#tsPreview-content-preview-wrapper');
						}
					}
				}
			});
		}
	}
	
	// issueKey: ABC-123
	// content: velocity markup etc
	// contentIsSubject : true, false
	// contentToRenderMarkup: velocity, wiki, velowiki
	// contentType: text, html
	function previewTemplateSetContent(issueKey, content, contentIsSubject, cssStyleSource, contentToRenderMarkup, contentType, divToUpdate)
	{
		if (!content)
		{
			console.error('preview() content is undefined');
			return;
		}
	  		  	
	  	AJS.$("form[name='jemhPreviewForm'] #atl_token").val(jemhAtlToken);
	  	AJS.$("form[name='jemhPreviewForm'] #testIssueKey").val(issueKey);
	  	
	  	AJS.$("form[name='jemhPreviewForm'] #contentCssStyle").val(cssStyleSource);
	  	AJS.$("form[name='jemhPreviewForm'] #contentToRenderMarkup").val(contentToRenderMarkup);
	  	AJS.$("form[name='jemhPreviewForm'] #contentToRenderType").val(contentType);
	  	AJS.$("form[name='jemhPreviewForm'] #contentToRender").val(content);

		var postData=AJS.$("form[name='jemhPreviewForm']").serialize();
	  	
		// contentType: sent to the server as a header
		// dataType is the response
		var jqXHR=AJS.$.ajax({
			type:"POST",
			url:formUrl,			
			dataType:"text",
			data:postData,
			timeout:60000
		}); // post
		
	  	jqXHR.done(function(data, textStatus, errorThrown) {

	  		if (contentIsSubject==true)
	  		{
	  			var oneline=data.replace(/(\r\n|\n|\r)/gm," ");
	  			//http://stackoverflow.com/questions/1219860/html-encoding-in-javascript-jquery
	  			AJS.$(divToUpdate).html(AJS.escapeHtml(oneline));
	  		}
	  		else
	  		{
	  			if (contentType=='text') {
  					AJS.$(divToUpdate).html(AJS.escapeHtml(data));
	  			} else {
  					AJS.$(divToUpdate).html(data);
	  			}
	  		}
	  			
	  	}).fail(function(data, textStatus, errorMessage) {
			console.error("Preview fail: textStatus="+textStatus+", errorMessage: "+errorMessage);
			AJS.messages.error(divToUpdate, {
			   title:"TemplateSet Render Failure",
			   body: '<p>Status: '+textStatus+', error: '+errorMessage+'</p>'
			});			
	  	});
	}
	
	function cloneSelectsFrom( sourceSelectStr) {
		
		var toListSelected=AJS.$("#tolistcf").val();
		var ccListSelected=AJS.$("#cclistcf").val();
		var bccListSelected=AJS.$("#bcclistcf").val();
		
		AJS.$("#tolistcf").find('option').remove().end().append(AJS.$(sourceSelectStr+" > option").clone());
		if (toListSelected) {
			AJS.$("#tolistcf option[value="+toListSelected+"]").attr('selected', 'selected');
		}
		
		AJS.$("#cclistcf").find('option').remove().end().append(AJS.$(sourceSelectStr+" > option").clone());
		if (ccListSelected) {		
			AJS.$("#cclistcf option[value="+ccListSelected+"]").attr('selected', 'selected');
		}
		
		AJS.$("#bcclistcf").find('option').remove().end().append(AJS.$(sourceSelectStr+" > option").clone());
		if (bccListSelected) {
			AJS.$("#bcclistcf option[value="+bccListSelected+"]").attr('selected', 'selected');
		}
	}
	
	function setupCustomFieldsVisible() {
		if (AJS.$('#showAllCustomFields').prop("checked")) {
			cloneSelectsFrom("#adhocAllIssueCustomFieldList");		  
		} else {
			cloneSelectsFrom("#adhocFilteredIssueCustomFieldList"); 		
		}
	}

	function applyAddCommentFieldVisibility(){
		if (AJS.$('#addContentAsComment').prop("checked")) {
			AJS.$('#addContentAsCommentFields').show('fast');
		} else {
			AJS.$('#addContentAsCommentFields').hide('fast');
		}
	}
	
	function initPostFunctionEditor() {
		subjectEditor=buildAceEditor('adHocSubmitForm', 'subject-editor', 'subject-statusBar', 'subject', 'velocity');
		AJS.$("#subject-preview-wrapper").hide();				
		AJS.$("#subject-preview_link").click(function(e) {
		  	e.preventDefault();
			if (AJS.$("#subject-preview-wrapper").is(":hidden"))
			{
			  	showCustomContentPreview(subjectEditor, "#subject-edit-wrapper", "#subject-preview-wrapper", "text");
			} 
			else
			{
			  	showEditor("#subject-edit-wrapper", "#subject-preview-wrapper");
			}
		  	return false;													  			  
		}); // click
		
		contentEditor=buildAceEditor('adHocSubmitForm', 'content-editor', 'content-statusBar', 'content', 'velocity');
		
		AJS.$("#content-preview-wrapper").hide();
		AJS.$("#content-preview_link").click(function(e) {
		  	  e.preventDefault();
			  if (AJS.$("#content-preview-wrapper").is(":hidden"))
			  {
			  	showCustomContentPreview(contentEditor, "#content-edit-wrapper", "#content-preview-wrapper", AJS.$("#contentType option:selected").val());
			  } 
			  else
			  {
			  	showEditor("#content-edit-wrapper", "#content-preview-wrapper");
			  }
		      return false;													  
		}); // click
	
		AJS.$("#adHocTemplate").change(function(){
			setupVisibleFields();
			
			var issueKey=AJS.$("#issueKey").val();
			if (issueKey) {
				var isRegexpMatch=issueKey.match('[A-Za-z0-9]+-[0-9]+');
				if (isRegexpMatch) {
					var selectedTemplateId=AJS.$("#adHocTemplate").find(":selected").val();
					if (selectedTemplateId!="0") {
						refreshTemplateSetPreview(issueKey);
					}
				} else {
					clearTemplateSetPreview();
				}
			}
		});
	
		mailHeaderScriptEditor=buildAceEditor('adHocSubmitForm', 'mailHeaderScript-editor', 'mailHeaderScript-statusBar', 'mailHeaderScript', 'velocity');
		showEditor("#mailHeaderScript-edit-wrapper", "#mailHeaderScript-preview-wrapper");		
		AJS.$("#mailHeaderScript-preview_link").click(function(e) {
		  	  e.preventDefault();
			  if (AJS.$("#mailHeaderScript-preview-wrapper").is(":hidden"))
			  {
			  	showCustomContentPreview(mailHeaderScriptEditor, "#mailHeaderScript-edit-wrapper", "#mailHeaderScript-preview-wrapper", 'text');
			  } 
			  else
			  {
			  	showEditor("#mailHeaderScript-edit-wrapper", "#mailHeaderScript-preview-wrapper");
			  }
		      return false;													  
		}); // click

		AJS.$("#transportKey").change(function(){
			setupVisibleFields();
			setupDefaultSlackContent();
		});

		AJS.$("#contentType").change(function(){
			var selectedTemplateId=AJS.$("#adHocTemplate").find(":selected").val();
			if (selectedTemplateId!="0") {
				var issueKey=AJS.$("#issueKey").val();
				refreshTemplateSetPreview(issueKey);
			}
		});
		
		AJS.$("#showAllCustomFields").change(function(){
			setupCustomFieldsVisible();
		});
			
		AJS.$(".jemh-preview-button").hide();		
		AJS.$("#issueKey").keyup(function() {
			var issueKey=AJS.$("#issueKey").val();
			var isRegexpMatch=issueKey.match('[A-Za-z0-9]+-[0-9]+');
			var selectedTemplateId=AJS.$("#adHocTemplate").find(":selected").val();
			
			if ((issueKey!="" || issueKey.length>=4) && isRegexpMatch) {
				AJS.$(".preview-issue-selected-container").html('');
				AJS.$(".jemhSendByTestButton").removeAttr("disabled");
				AJS.$(".jemh-preview-button").show();
				
				if (selectedTemplateId!="0") {
					refreshTemplateSetPreview(issueKey);
				}
			} else {
				AJS.$(".preview-issue-selected-container").html('<span class="aui-lozenge">No Preview Context</span>');
				AJS.$(".jemhSendByTestButton").attr("disabled", "disabled");
				AJS.$(".jemh-preview-button").hide();
				
				if (selectedTemplateId=="0") {
					clearTemplateSetPreview();
				}
			}
		});		
		
		updateVeloWikiHelpLinkVisibility();
		
		AJS.$('#customContentMarkup').change(function(ev) {
			if (AJS.$('#content-preview-wrapper').is(":visible"))
			{
				showCustomContentPreview(contentEditor, "#content-edit-wrapper", "#content-preview-wrapper", AJS.$("#contentType option:selected").val());
			}
			updateVeloWikiHelpLinkVisibility();
		});

		AJS.$("#ts-preview_link").click(function(e) {
			e.preventDefault();
			var issueKey=AJS.$("#issueKey").val();
			refreshTemplateSetPreview(issueKey);
		  	return false;													  			  
		}); //click		


		AJS.$("#addContentAsComment").change(function() {
			applyAddCommentFieldVisibility();
		});

		AJS.$(".jemhSendByTestButton").click(function(){
			if (AJS.$(".jemhSendByTestButton").attr("disabled")=="disabled")
			{
				console.error('invalid issue key set, ignoring');
				return;
			}
			
			AJS.$('#jemh-message-bar').empty();
			var subjectVal=AJS.$('#template-subject').val();
			var contentVal=AJS.$('#template-content').val();
			var selectedTemplateId=AJS.$("#adHocTemplate").find(":selected").val();
			if (selectedTemplateId=="0") {
				subjectVal=subjectEditor.getSession().getValue();
				subjectVal=subjectVal.replace(/(\r\n|\n|\r)/gm," ");
				AJS.$('#template-subject').val(subjectVal);
				
				contentVal=contentEditor.getSession().getValue();
				AJS.$('#template-content').val(contentVal);
			}
			
			var mailHeaderScript=mailHeaderScriptEditor.getSession().getValue();
			AJS.$('#mailHeaderScript-content').val(mailHeaderScript);
			
			var convertedData = AJS.$("form[name='jiraform']").serialize();

			var jqXHR=AJS.$.ajax({
				type:"POST",					
				url:baseUrl+"/rest/jemh/latest/api/workflow/notification/test?atl_token="+jemhAtlToken, 
				data: convertedData,
				format: "json",
				success: function(data, textStatus, errorMessage) {
					var msg='';
					if ( data && data.Message ) {  
					    msg=data.Message;  
					}  							
					AJS.messages.success("#jemh-message-bar", {
						title: "Test Postfunction message sent successfully", 
				       	body: "The message was successfully sent: "+msg,
			          	fadeout: true
					});	},
				error: function(xhr, errorType, exception) {
			        AJS.messages.error("#jemh-message-bar", {
			        	title: "Test Postfunction message failed to send", 
			          	body: "<p>"+xhr.responseText+"</p>"
			        }); }							
		    });
	    });
		
		// ---- Postfunction init
		
		AJS.$("form[name='jiraform']").addClass("aui").submit(function( event ) {
				var subjectTextarea = AJS.$('form[name="jiraform"] textarea[name="subjectOverride"]');
				if(subjectTextarea)
				{
					var updatedValue=subjectEditor.getSession().getValue();
					subjectTextarea.val(updatedValue);
				}
				else
				{
					console.error('subject textarea not found by name');
				}			 
				
				var contentTextarea = AJS.$('form[name="jiraform"] textarea[name="contentOverride"]');
				if(contentTextarea)
				{
					var updatedValue=contentEditor.getSession().getValue();
					contentTextarea.val(updatedValue);
				}
				else
				{
					console.error('content textarea not found by name:');
				}
				
				var mailHeaderScriptTextarea = AJS.$('form[name="jiraform"] textarea[name="mailHeaderScript"]');
				if(mailHeaderScriptTextarea)
				{
					var updatedValue=mailHeaderScriptEditor.getSession().getValue();
					mailHeaderScriptTextarea.val(updatedValue);
				}
				else
				{
					console.error('mailHeaderScript textarea not found by name:');
				}		
		});
		
		setupVisibleFields();
		setupVisibleAttachmentSourceFields();		
		AJS.$('#attachmentSelectionMethod').on("click", function() {
			setupVisibleAttachmentSourceFields();
		});
		
	    AJS.$('.mod-header').on("click", function() {
	  		if ( AJS.$(this).parent().hasClass('expanded') )
	  		{
	  			AJS.$(this).parent().removeClass("expanded").addClass("collapsed");
	  		}
	  		else
	  		{
	  			AJS.$(this).parent().removeClass("collapsed").addClass("expanded");
	  		}
		});
	    
	    addDyamicallyGeneratedFormToBody();
	    AJS.$("#jemh-pf-loading").hide();
	    AJS.$(".jemh-pf-tr").show("fast");
	}
	
	function hookFromAndReplyToCustomFieldSelects() {
		//sender address
		AJS.$("#senderAddressCfId").change(function(){
			var selectedVal=AJS.$(this).val();
			if (selectedVal==""|| selectedVal=="0")
			{
				AJS.$(".static-sender-address-group").show();
			}
			else
			{
				AJS.$(".static-sender-address-group").hide();
			}
		});
		
		if (AJS.$("#senderAddressCfId").val()=="" || AJS.$("#senderAddressCfId").val()=="0") {
			AJS.$(".static-sender-address-group").show();
		} else {
			AJS.$(".static-sender-address-group").hide();
		}
		
		//sender personal
		AJS.$("#senderPersonalCfId").change(function(){
			var selectedVal=AJS.$(this).val();
			
			if (selectedVal==""|| selectedVal=="0")
			{
				AJS.$(".static-sender-personal-group").show();
			}
			else
			{
				AJS.$(".static-sender-personal-group").hide();
			}
		});
		if (AJS.$("#senderPersonalCfId").val()=="" || AJS.$("#senderPersonalCfId").val()=="0") {
			AJS.$(".static-sender-personal-group").show();
		} else {
			AJS.$(".static-sender-personal-group").hide();
		}

		
		//reply-to address
		AJS.$("#replyToAddressCfId").change(function(){
			var selectedVal=AJS.$(this).val();
			if (selectedVal==""|| selectedVal=="0")
			{
				AJS.$(".static-reply-to-address-group").show();
			}
			else
			{
				AJS.$(".static-reply-to-address-group").hide();
			}
		});
		if (AJS.$("#replyToAddressCfId").val()=="" || AJS.$("#replyToAddressCfId").val()=="0") {
			AJS.$(".static-reply-to-address-group").show();
		} else {
			AJS.$(".static-reply-to-address-group").hide();
		}

		//reply-to personal
		AJS.$("#replyToPersonalCfId").change(function(){
			var selectedVal=AJS.$(this).val();
			if (selectedVal==""|| selectedVal=="0")
			{
				AJS.$(".static-reply-to-personal-group").show();
			}
			else
			{
				AJS.$(".static-reply-to-personal-group").hide();
			}
			
		});
		if (AJS.$("#replyToPersonalCfId").val()=="" || AJS.$("#replyToPersonalCfId").val()=="0") {
			AJS.$(".static-reply-to-personal-group").show();
		} else {
			AJS.$(".static-reply-to-personal-group").hide();
		}
	}

	//If the transport selection is slack, a default value should be provided to guide users to follow the correct slack json format as per: https://thepluginpeople.atlassian.net/wiki/spaces/JEMH/pages/944930880/Use+the+Slack+Notification+Transport#PostFunction-Slack-notification
	function setupDefaultSlackContent(){
		let selectedTransport = AJS.$("#transportKey").val();
		console.log(selectedTransport);
		if(selectedTransport === "ppl-jemh-slack"){
			let customContent = contentEditor.getSession().getValue();
			console.log(customContent);
			if(!customContent || customContent === ""){
				let defaultContent = "{\"text\": \"This is a line of text in a channel.\\nAnd this is another line of text.\"}";
				contentEditor.getSession().setValue(defaultContent);
			}
		}
	}

	
	function setupHooks()
	{
		hookFromAndReplyToCustomFieldSelects();
	}
	
	setupHooks();	
	
	if (aceLoaded==false) {
	    loadAce(function() { initPostFunctionEditor(); });
	} else {
		console.error('ACE already loaded on this page');
		initPostFunctionEditor();
	}
});
