var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();

AJS.$(document).ready(function(){
    var originalProfileId;

    AJS.$('.updateFromXml').click(function(e){
        var updateBtn = AJS.$(this);
        if(!updateBtn.attr('disabled')){
            originalProfileId = AJS.$(this).attr('data-profile-id');
            AJS.dialog2('#updateProfileFromXml').show();
        }else{
            AJS.$("#profile-message-bar").empty();
            AJS.messages.error("#profile-message-bar", {
                title: "Profile Update from XML", 
                body: "Please enable <b>Profile Auditing</b> to use this feature",
                fadeout: true
            });
        }
    });

    AJS.$('#uploadProfileXml').change(function(){
        var submitBtn = AJS.$('#updateProfile-submit-btn');
        var value = AJS.$(this).val();
        if(value){
            submitBtn.removeAttr('disabled');
            submitBtn.attr('aria-disabled', false);
        }
    });

    AJS.$("form#jemhProfileUpdateForm").submit(function (e) {        
        e.preventDefault();
        var form = AJS.$(this);
        var actionUrl = form.attr('action');

        var formData = new FormData();
        if (AJS.$('#uploadProfileXml').prop('files').length > 0) {
            var file = AJS.$('#uploadProfileXml').prop('files')[0];
            formData.append('profileXml', file, file.name);
            var atlToken = AJS.$('#atl-token').val();
            updateProfileFromXml(originalProfileId, atlToken, actionUrl, formData);
        }
    });

    AJS.$('#updateProfile-cancel-btn').click(function(e){
        e.preventDefault();
        resetUiState();
    });

    AJS.$('#uploadProfileXmlHelp').click(function(e){
        var win = window.open("https://thepluginpeople.atlassian.net/wiki/spaces/JEMH/pages/1187807247/Update+JEMH+Profile+via+XML", '_blank');
        win.focus();
    });
})

function updateProfileFromXml(profileId, atlToken, actionUrl, formData){
    var postUrl = actionUrl + "?profileId="+profileId+"&atl_token="+atlToken;
    AJS.$.ajax({
        url: postUrl,
        type:"POST",
        data: formData,
        dataType: 'json',
        contentType: false,
        processData: false,
        success: function(res){
            AJS.$("#profile-message-bar").empty();
            AJS.messages.success("#profile-message-bar", {
                title: "Profile Update from XML", 
                body: res.message,
                fadeout: true
            });
            resetUiState();
        },
        error: function(res){
            AJS.$("#profile-message-bar").empty();
            AJS.messages.error("#profile-message-bar", {
                title: "Profile Update from XML", 
                body: "Error code: "+res.status +"; message: "+ res.responseJSON.message
            });
            resetUiState();
        }
    });
}

function resetUiState(){
    AJS.dialog2("#updateProfileFromXml").hide();
    AJS.$('#uploadProfileXml').val("");
    var submitBtn = AJS.$('#updateProfile-submit-btn');
    submitBtn.attr('disabled');
    submitBtn.attr('aria-disabled', true);
}