AJS.$(document).ready( function(){	
	console.log('templateset.js loading');
	
	var subjectEditor; 	
	var textEditor;
	var htmlEditor;
	var commentEditor;
	
	if(window.location.href.indexOf("JEMHTemplates!edit") !== -1)
	{
		//Only show the ace editor in edit mode
		console.log("Building ace editor");
		commentEditor = buildAceEditor('jemhTemplatePreviewDataForm', 'comment-editor', 'comment-statusBar', 'comment', 'velocity');  //<!-- buildAceEditor( formId, aceEditorDivId, aceStatusBarDivId, formTextAreaName, mode ) -->
	}
		
	AJS.$(".jemh-preview-button").hide();
	
	AJS.$("#testIssueKey").keyup(function() {	
		var issueKey=AJS.$("#testIssueKey").val();
		var isRegexpMatch=issueKey.match('[A-Za-z0-9]+-[0-9]+');
		if ((issueKey!="" || issueKey.length>=4) && isRegexpMatch) {
			AJS.$(".preview-issue-selected-container").html('');
			AJS.$(".jemh-preview-button").show();
		} else {
			AJS.$(".preview-issue-selected-container").html('<span class="aui-lozenge">No Preview Context</span>');
			AJS.$(".jemh-preview-button").hide();
		}	
	});

	if (AJS.$("#subject-preview-wrapper").length>0) {
		subjectEditor=buildAceEditor('jemhTemplateSetEditForm', 'subject-editor', 'subject-statusBar', 'subject', 'velocity');
		AJS.$("#subject-preview-wrapper").hide();
		AJS.$("#subject-preview_link").click(function(e) {
		  	e.preventDefault();
			if (AJS.$("#subject-preview-wrapper").is(":hidden"))
			{
			  	showPreview(subjectEditor, "#subject-edit-wrapper", "#subject-preview-wrapper", "text");
			} 
			else
			{
			  	showEditor("#subject-edit-wrapper", "#subject-preview-wrapper");
			}
		  	return false;													  			  
		}); //click		
	}	

	if (AJS.$("#text-preview-wrapper").length>0) {
		textEditor=buildAceEditor('jemhTemplateSetEditForm', 'text-editor', 'text-statusBar', 'text', 'velocity');
		AJS.$("#text-preview-wrapper").hide();
		AJS.$("#text-preview_link").click(function(e) {
		  	  e.preventDefault();
			  if (AJS.$("#text-preview-wrapper").is(":hidden"))
			  {
			  	showPreview(textEditor, "#text-edit-wrapper", "#text-preview-wrapper", "text");
			  } 
			  else
			  {
			  	showEditor("#text-edit-wrapper", "#text-preview-wrapper");
			  }
		      return false;													  
		}); //click		
	}
	
	if (AJS.$("#html-preview-wrapper").length>0) {
		htmlEditor=buildAceEditor('jemhTemplateSetEditForm', 'html-editor', 'html-statusBar', 'html', 'velocity');
		AJS.$("#html-preview-wrapper").hide();
		AJS.$("#html-preview_link").click(function(e) {
		      e.preventDefault();
			  if (AJS.$("#html-preview-wrapper").is(":hidden"))
			  {
			  	showPreview(htmlEditor, "#html-edit-wrapper", "#html-preview-wrapper", "html");
			  } 
			  else
			  {
			  	showEditor("#html-edit-wrapper", "#html-preview-wrapper");
			  }
		      return false;													  
		}); //click		
	}
	
	function showPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs) {
	  	AJS.$(editWrapperDivId).hide();
	  	AJS.$(previewWrapperDivId).show();
	  	AJS.$(previewWrapperDivId).text("Rendering, please wait...");
	  	//AJAX POST of content to render
	  	if (showTypeAs==="html") {
	  		AJS.$("#contentCssStyle").val(AJS.$("#cssStyleSource option:selected").val());
	  	} else {
	  		AJS.$("#contentCssStyle").val("-1");
	  	}
	  	var css = AJS.$('#contentCssStyle').val();
	  	if (css === "-2") //Default JSD
	  	{
            AJS.$("#contentCssStyle").val(AJS.$("#cssStyleSource option:selected").val());
			renderPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs);
		} else if (css === "-1") //No CSS
		{
			AJS.$("#contentCssStyle").val(AJS.$("#cssStyleSource option:selected").val());
			renderPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs);
		} else if ( css === "0") //Default Jira
		{
			AJS.$("#contentCssStyle").val(AJS.$("#cssStyleSource option:selected").val());
			renderPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs);
		} else if (css > "0") //Custom Css
		{
			AJS.$("#contentCssStyle").val(AJS.$("#cssStyleSource option:selected").val());
			renderPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs);
		} else
			{
				AJS.$("#contentCssStyle").val("-1");
				renderPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs);
			}
	}

	function renderPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs)
	{
		AJS.$("#contentToRender").val(editor.getSession().getValue());
		if(showTypeAs === "html")
		{
			AJS.$("#contentToRenderType").val("html");

		} else
			{
				AJS.$("#contentToRenderType").val("text");
			}
		AJS.$("#commentToRender").val(commentEditor.getSession().getValue());

		var postData=AJS.$('#jemhTemplatePreviewDataForm').serialize();
		var formUrl = AJS.$('#jemhTemplatePreviewDataForm').attr('action');
		//contentType: sent to the server as a header
		//dataType is the response
		var jqXHR=AJS.$.ajax({
			type:"POST",
			url:formUrl,
			dataType:"text",
			data:postData,
			timeout:60000
		}); //post

		jqXHR.done(function(data, textStatus, errorThrown) {
			if (showTypeAs==='text')
			{
				//http://stackoverflow.com/questions/1219860/html-encoding-in-javascript-jquery
				if (editor===subjectEditor) {
					data=data.replace(/(\r\n|\n|\r)/gm," ");
				}
				data=('<pre>'+AJS.$("<div/>").text(data).html()+'</pre>');
			}
			AJS.$(previewWrapperDivId).html(data);

		}).fail(function(data, textStatus, errorMessage) {
			console.error("Preview failed: textStatus="+textStatus+", errorMessage: "+errorMessage);
			AJS.messages.generic(previewWrapperDivId, {
				title:"Preview rendering failed",
				body: '<p>Status: '+textStatus+', error: '+errorMessage+'</p>'
			});
		});
	}
	
	function showEditor(editWrapperDivId, previewWrapperDivId) {
	  	AJS.$(previewWrapperDivId).hide();
	  	AJS.$(editWrapperDivId).show();
	  	AJS.$(previewWrapperDivId).text("");
	  	AJS.$("#contentToRender").val("");
	}

	//Initialise project selector
	AJS.$("#scopedProjectKeys").auiSelect2({
			placeholder: "None (Global)",
			allowClear: true
		});

	//Initialise project filter
	AJS.$("#filterByProject").auiSelect2();
	//submit on change
	AJS.$("#filterByProject").change(function(e) {
		AJS.$("#jemh-template-filter-form").submit();
	});

	//Hide Theme div if transport is not 'Email'
	AJS.$('#transportKey').change(function()
		{
			var value = AJS.$("#transportKey option:selected").val();
			if (value === "default-email")
			{
				AJS.$('#themeSelect').show();
			} else
			{
				AJS.$('#themeSelect').hide();
			}
		});

	//Edit Templateset, when the Css select is changed, get the new value to be rendered into the editor.
	AJS.$('#cssStyleSource').change(function(){
		//var value = AJS.$("#cssStyleSource option:selected").val();
		AJS.$("#contentCssStyle").val(AJS.$("#cssStyleSource option:selected").val());
	});

	//Change select to show JSD values if Jsd Theme selected
	AJS.$("#themeSelect").change(function()
	{
		let theme = AJS.$("#themeSelect option:selected").val();
		if(theme === "Jsd")
		{
			console.log("Jsd selected");
			AJS.$("#eventType").hide();
			AJS.$("#jsdEventType").show();
		} else if (theme === "Jira")
		{
			console.log("Jira selected");
			AJS.$("#jsdEventType").hide();
			AJS.$("#eventType").show();
		}
		else
		{
			console.log("Unknown selection, reverting to Jira");
			AJS.$("#jsdEventType").hide();
			AJS.$("#eventType").show();
		}
	});

	//Set the EventType to JSDEventType when changed
	AJS.$("#jsdIssueEvent").change(function()
	{
		var selectedIssue = AJS.$("#jsdIssueEvent option:selected").val();
		AJS.$("#issueEvent").val(selectedIssue);
	});

	AJS.$("#uploadTemplateXml").change(function(){
		let importValue = AJS.$("#uploadTemplateXml").val();
		if(importValue != null)
		{
			AJS.$("#uploadTemplateXmlSubmit").attr('disabled', false);
		} else
		{
			AJS.$("#uploadTemplateXmlSubmit").attr('disabled', true);
		}
	});

}); //ready


